/**
 * javascript functions for editing news
 * 
 * Author: Jonas Scheer
 */


/**
 * sends an ajax request to change the main news image
 */
function quickChangeMainImage(imgId, newsId, starImgPath, emptyStarImgPath) {
//	alert(newsId +" " +imgId);
	var myData = {'img_id': imgId};
//	alert(starImgPath);
	$.ajax({
		type: "POST",
		dataType:"json",
		url: "?r=news/changeMainImage/newsId/" +newsId,
		data: myData,
		success:function(data){
			
			if(data['valid']) {				  
				if(data['oldMainImageId'] && data['oldMainImageId'] >= 0) {	
					$("#star_news_img_" +(data['oldMainImageId'])).attr("src", emptyStarImgPath);
					$("#star_news_img_" +imgId).attr("src", starImgPath);
				}
			}
			else {  					
				
				alert('image NOT deleted: ')			// TODO: error message
			}			
       	},
	   error: function(data, textStatus, errorThrown) { // if error occured
		   alert('image NOT deleted ERROR: ')			// TODO: error message
	    },
	});
}

/**
 * sends an ajax request to delete a news image
 */
function quickDeleteImage(imgId, newsId, starImgPath) {
	
	var myData = {'img_id': imgId};
	$.ajax({
		type: "POST",
		dataType:"json",
		url: "?r=news/deleteNewsImage/newsId/" +newsId,
		data: myData,
		success:function(data){
			
			if(data['valid']) {				   		
				
	        	$("#edit_image_container_"+imgId).hide("fast");
	        	if(data['newMainImageId'] && data['newMainImageId'] >= 0) {	
	        		$("#star_news_img_" +(data['newMainImageId'])).attr("src", starImgPath);
	        	}
			}
			else {  					
				
//				alert('image NOT deleted: ' +data['error'])			// TODO: error message
			}			
       	},
	   error: function(data, textStatus, errorThrown) { // if error occured
						
	    },
	});
}