<?php

/**
 * parser that uses a like to a tt-info player profile
 * and parses it's tts-value.
 */
class scoreServiceParserTableTennisTts {
    
    public $u_id = Null;          // integer starting with 1
    public $tts = Null;    	
    public $evaluated_games = 0;	
    public $last_update = Null;
    public $score_service_link = Null;
    
    
    
   
    /**
     * returns true, if domain is availible, false if not
     * 
     * @param unknown $domain
     * @return boolean
     */
    private function isDomainAvailible($domain)
    {
    	//check, if a valid url is provided
    	if(!filter_var($domain, FILTER_VALIDATE_URL))
    	{
    		return false;
    	}
    	
    	//initialize curl
    	$curlInit = curl_init($domain);
    	curl_setopt($curlInit,CURLOPT_CONNECTTIMEOUT_MS, 1200);		// TODO: adjust time ??
    	curl_setopt($curlInit,CURLOPT_TIMEOUT_MS, 1800);			// TODO: adjust time for server version ??
    	curl_setopt($curlInit,CURLOPT_HEADER,true);
    	curl_setopt($curlInit,CURLOPT_NOBODY,true);
    	curl_setopt($curlInit,CURLOPT_RETURNTRANSFER,true);
    	
    	//get answer
    	$response = curl_exec($curlInit);    
    	$httpcode = curl_getinfo($curlInit, CURLINFO_HTTP_CODE);
    	
    	$errorNo = curl_errno($curlInit);
    	echo $errorNo;
    	if($errorNo == 28)
    		return false;
    	
    	
    	curl_close($curlInit);
    	echo "httpcode: " . $httpcode . " - " . $domain . " - ";
    	if($httpcode>=200 && $httpcode<300){
    		echo "TRUE";
			return true;
    	} else {
    		echo "FALSE";
			return false;
    	}
    	
    	
//     	echo $response;
    	// HTTP/1.1 200 OK Date: Wed, 03 Sep 2014 05:10:16 GMT Server: Apache Set-Cookie: sess=39141704-1409721016 Content-Type: text/html
//     	if ($response) return true;
    
    	return false;
    }
    
    
    /**
     * 
     */
    public function parseTTS($service_link) {
    	
    	$service_link = "http://tt-info.de/tt-online.cgi?akt=1058&version=neu&s_p_id=174921";
//     	$service_link = "http://tt-info.de/aasdwdadawdawda";
    	
    	libxml_use_internal_errors(true);
    	
    	$doc = new DOMDocument();
    	if(!$this->isDomainAvailible($service_link)) {
    		return Null;
    	}
    	$doc->loadHTMLFile($service_link);
    	
    	
    	$xpath = new DOMXPath($doc);
    	$ttsStr = Null;
    	$evaluated_games = Null;
    	$parsingSuccessuful = false;
    	foreach( $xpath->query('//div[contains(attribute::class, "info")]') as $e ) {
    		
    		$mainStr = $e->nodeValue;
    		
    		$findStr = 'aktueller TTS ';
    		$pos = strpos($mainStr, $findStr) + strlen($findStr);
    		$mainStr = substr ($mainStr , $pos);
    		
    		$findStr = ' ';
    		$pos = strpos($mainStr, $findStr)-1;
    		$tmpTtsStr = substr ($mainStr , 0, $pos);
    		$mainStr = substr ($mainStr , $pos);
    		
    		$findStr = 'aktueller Q-TTS ';
    		$pos = strpos($mainStr, $findStr) + strlen($findStr);
    		$mainStr = substr ($mainStr , $pos);
    		$findStr = ' ';
    		$pos = strpos($mainStr, $findStr) + strlen($findStr);
    		$mainStr = substr ($mainStr , $pos);
    		$mainStr = substr ($mainStr, 11);
    		
    		$findStr = ' gewertete Spiele';
    		$pos = strpos($mainStr, $findStr)-1;
    		$tmpEvaluated_games = substr ($mainStr , 1, $pos);
    		
    		// do not delete, can be used for testing if the parser needs to be adjusted
//     		echo $tmpTtsStr, "<br />\n";
//     		echo strlen($tmpTtsStr), "<br />\n";
//     		echo $tmpEvaluated_games, "<br />\n";
//     		echo strlen($tmpEvaluated_games), "<br />\n";

    		$ttsStr = $tmpTtsStr;
    		$evaluated_games = $tmpEvaluated_games; 
    		
    		if(is_numeric($ttsStr) && is_numeric($evaluated_games)) {
    			$parsingSuccessuful = true;
    			break;
    		}
    		else {
    			$ttsStr = Null;
    			$evaluated_games = Null;
    		}
    	}
    	
    	//
    	// parsing was successful
    	// 
    	if($parsingSuccessuful) {
    		
    		return array('tts' => $ttsStr, 'evaluated_games' => $evaluated_games);
    	}
    	
    	return null;
    }
    
}

?>