<?php

// uncomment the following to define a path alias
// Yii::setPathOfAlias('local','path/to/local-folder');

// This is the main Web application configuration. Any writable
// CWebApplication properties can be configured here.
return array(
	'basePath'=>dirname(__FILE__).DIRECTORY_SEPARATOR.'..',
	'name'=>'TTV Hasborn',
	
	/*  Setting PHP timezone to UTC.
	 * This is not the database timezone, but the time zone used by php's date() and time() functions.
	 * It takes the server's time, and converts it to UTC.
	 * So even if the server's clock is set to a different timezone, this should still give you UTC. 
	 */
	'timeZone'=>'GMT',
		
	'sourceLanguage' => 'en_us', // Source Language (app language) (default english)
	
	'language' => 'de', // Target language (user's language / locale)
		
		
	// preloading 'log' component
	'preload'=>array('log'),

	// autoloading model and component classes
	'import'=>array(
		'application.models.*',
        'application.models.custom.*',
		'application.models.custom.table_tennis.*',
		'application.apps.*',
		'application.components.*',
		'application.controllers.SiteController',
		//'ext.easyimage.EasyImage',
		'application.extensions.easyimage.EasyImage',
		'ext.enums2.*',
	),

	'modules'=>array(
		// uncomment the following to enable the Gii tool
		/*
		'gii'=>array(
			'class'=>'system.gii.GiiModule',
			'password'=>'Enter Your Password Here',
			// If removed, Gii defaults to localhost only. Edit carefully to taste.
			'ipFilters'=>array('127.0.0.1','::1'),
		),
		*/
	),

	// application components
	'components'=>array(
		'user'=>array(
			// enable cookie-based authentication
			'allowAutoLogin'=>true,
		),
		'request'=>array(
                'enableCookieValidation'=>true,
                ),
                
		// uncomment the following to enable URLs in path-format
		
		'urlManager'=>array(
			'urlFormat'=>'path',
			'showScriptName' => false,
			'rules'=>array(
			
                // handle local lan server	
                'http://<ip1:\d+>.<ip2:\d+>.<ip3:\d+>.<ip4:\d+>'			// controller & action are not given --> goto homeURL;
                		=> 'news/newsFeed/clubUrl/<ip1>.<ip2>.<ip3>.<ip4>', // resolve ip address to get the club id
                'http://<ip1:\d+>.<ip2:\d+>.<ip3:\d+>.<ip4:\d+>/<clubId:\w+>/<c_id:\d+>'		// controller & action are not given --> goto homeURL;
                		=> 'news/newsFeed/clubUrl/<ip1>.<ip2>.<ip3>.<ip4>/<clubId>/<c_id>', 	// club_id given as $_GET
               																				
                'http://<ip1:\d+>.<ip2:\d+>.<ip3:\d+>.<ip4:\d+>/<controller:\w+>/<action:\w+>/*'
                		=> '<controller>/<action>/clubUrl/<ip1>.<ip2>.<ip3>.<ip4>',
                		
                // handle online urls with domains 
                // (first: with www as prefix; second: without www)               
                'http://www.<url>.<tld:(de|com|net)>'			// controller & action are not given --> goto homeURL;
                		=> 'news/newsFeed/clubUrl/<url>.<tld>',		// resolve ip address to get the club id
                'http://www.<url>.<tld:(de|com|net)>/<clubId:\w+>/<c_id:\d+>'			// controller & action are not given --> goto homeURL;
                		=> 'news/newsFeed/clubUrl/<url>.<tld>/<clubId>/<c_id>',				// club_id given as $_GET
                'http://www.<url>.<tld:(de|com|net)>/<controller:\w+>/<action:\w+>/*'		// controller & action ARE given;
                		=> '<controller>/<action>/clubUrl/<url>.<tld>',							// club_id will be resolved by url, if this is not possible
                																				// $_GET[clubId] will be take into account,
                																				// otherwise no clubId can be assigned.
                
                		
             	'http://<url>.<tld:(de|com|net)>'
                		=> 'news/newsFeed/clubUrl/<url>.<tld>',
                'http://<url>.<tld:(de|com|net)>/<clubId:\w+>/<c_id:\d+>'
                		=> 'news/newsFeed/clubUrl/<url>.<tld>/<clubId>/<c_id>',
				'http://<url>.<tld:(de|com|net)>/<controller:\w+>/<action:\w+>/*'
						=> '<controller>/<action>/clubUrl/<url>.<tld>',				

			),
		),
				
		'db'=>array(
			'connectionString' => 'pgsql:host=localhost;port=5432;dbname=not_available_here',
			'emulatePrepare' => true,
			'username' => 'not_available_here',
			'password' => 'not_available_here',			// TODO: change on server
			'charset' => 'utf8',
			'initSQLs'=>array("SET TIME ZONE 'GMT';"),
		),
		
// 		'authManager'=>array(
// 				'class'=>'CPhpAuthManager',
// 				'defaultRoles'=>array('reader'),
// // 				'authFile' => 'path'                  // only if necessary
// 		),

		'authManager'=>array(
			'class'=>'CDbAuthManager',
            'connectionID'=>'db',
		),

		'rbac'=>array('class'=>'RbacComponent'),
                
            
        // facebook connection from yii extention
        'facebook'=>array(
                'class' => 'ext.yii-facebook-opengraph.SFacebook',
                'appId'=>'not_available_here', // needed for JS SDK, Social Plugins and PHP SDK
                'secret'=>'not_available_here', // needed for the PHP SDK
                //'fileUpload'=>false, // needed to support API POST requests which send files
                //'trustForwarded'=>false, // trust HTTP_X_FORWARDED_* headers ?
                'locale'=>'de_DE', // override locale setting (defaults to en_US)
                //'jsSdk'=>true, // don't include JS SDK
                'async'=>true, // load JS SDK asynchronously
                //'jsCallback'=>false, // declare if you are going to be inserting any JS callbacks to the async JS SDK loader
                'status'=>true, // JS SDK - check login status
                //'cookie'=>true, // JS SDK - enable cookies to allow the server to access the session
                'oauth'=>true,  // JS SDK - enable OAuth 2.0
                //'xfbml'=>true,  // JS SDK - parse XFBML / html5 Social Plugins
                //'frictionlessRequests'=>true, // JS SDK - enable frictionless requests for request dialogs
                //'html5'=>true,  // use html5 Social Plugins instead of XFBML
                //'ogTags'=>array(  // set default OG tags
                    //'title'=>'MY_WEBSITE_NAME',
                    //'description'=>'MY_WEBSITE_DESCRIPTION',
                    //'image'=>'URL_TO_WEBSITE_LOGO',
                //),
        ),
        
         // E-Mail extention for simply sending emails.
        'mailer' => array(
        // for smtp
        'class' => 'ext.YiiMailer-master.SmtpMailer',
        'server' => 'not_available_here',
        'port' => '25',
        'username' => 'not_available_here',
        'password' => 'not_available_here',

        // for php mail
		// 'class' => 'ext.mailer.PhpMailer',
    	),            
        
        'easyImage' => array(
        		'class' => 'ext.easyimage.EasyImage',
        		'driver' => 'Imagick',
        		'quality' => 40,
        		'cachePath' => '/images/image_cache/',
        		'cacheTime' => 2592000,
        		//'retinaSupport' => false,
        ),
        
        'mobileDetect' => array(
        		'class' => 'ext.MobileDetect.MobileDetect'
        ),
            
		'errorHandler'=>array(
			// use 'site/error' action to display errors
			'errorAction'=>'site/error',
		),
		'log'=>array(
			'class'=>'CLogRouter',
			'routes'=>array(
				array(
					'class'=>'CFileLogRoute',
					'levels'=>'error, warning',
				),
				// uncomment the following to show log messages on web pages
				/*
				array(
					'class'=>'CWebLogRoute',
				),
				*/
			),
		),
	),

	// application-level parameters that can be accessed
	// using Yii::app()->params['paramName']
	'params'=>array(
		// this is used in contact page
		'adminEmail'=>'tt@jscheer.de',
	),
);
