<?php

class ClubController extends Controller
{
	
	
	//
	//	TODO: connect getIsGuest() with isActive of usertable and club table
	//
	
	
	
	
	/**
	 * This is the default 'index' action that is invoked
	 * when an action is not explicitly requested by users.
	 */
	public function actionIndex()
	{
		// renders the view file 'protected/views/site/index.php'
		// using the default layout 'protected/views/layouts/main.php'
		$this->render('index');
	}
	
	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
		if($error=Yii::app()->errorHandler->error)
		{
			if(Yii::app()->request->isAjaxRequest)
				echo $error['message'];
			else
				$this->render('error', $error);
		}
	}
	
	
	/**
	 * evaluates the ajay request for changing a club
	 * 
	 */
	public function actionChangeClub($sValidationKey=Null) {	
		
// 		echo CJSON::encode(array('valid' => true));
// 		return;
		if(isset($sValidationKey)) {			
			
	
			$key = ClubChangeKey::model()->findByPk($sValidationKey);
			if(!isset($key)) {
				/*
				 * TODO: club could not be changed --> display better error message
				*/
				$this->render('loginError', array('error' => 'error'));
				return;
			}
			
			
			if(!Yii::app()->user->getIsGuest())
			{
				if($key->u_id != Yii::app()->user->name) {
					Yii::app()->user->logout();
				}
			}
			
			
			$userIdentity = new User_Identity(Null, Null);
			$userIdentity->useClubChangeKey($key->key);
							
			/*
			 * Login user
			*/
			$authReturn = $userIdentity->authenticate() ;
			if($authReturn == CUserIdentity::ERROR_NONE)
			{
				/*
				 * store login date within DB
				*/
				$connection=Yii::app()->db;
				$sql =  "UPDATE tbl_user SET ".
						"last_login = '". "now()" ."' ".
						"WHERE u_id = '".$userIdentity->username."';";
				$connection->createCommand($sql)->execute();
			
				Yii::app()->user->login($userIdentity);
			}
			else {
				/*
				 * TODO: club could not be changed --> display better error message
				 */
				User_Identity::removeRolePrivilidges($key->u_id);
				$userIdentity->clearState('club_id');
				$this->render('loginError', array('error' => $authReturn));
				return;
			}
			
			
			$redirectUrl = $this->createUrl('news/newsFeed', array('news_id' => -1));
			$this->redirect($redirectUrl);
			
			return;
		}
		else {
						
			$isUser = (!Yii::app()->user->getIsGuest());
			$access = Yii::app()->user->checkAccess('reader');
			if($isUser && $access) {
				$u_id = Yii::app()->user->id;
				
				if (Yii::app()->request->isAjaxRequest) {
					
					if(isset($_POST['club_id'])) {						
						
						$club_id = $_POST['club_id'];
							
						$transaction = Yii::app()->db->beginTransaction();
						try
						{
							
							
							$hasClub = HasClubs::model()->findByPk(array('u_id' => $u_id, 'club_id' => $club_id));
							if($hasClub) {
								$this->layout=false;
								header('Content-type: application/json');
									
								$date = CTimestamp::getDate(false, false, false);
								$hasClub->last_used = date('Y-m-d G:i:s', $date[0]);
									
								if(isset($hasClub->activated) && $hasClub->activated==true) {
									if($hasClub->validate()) {
										$hasClub->update();
									}
									else
										throw new CDbException('can not validate hasClub relation.');
								}
								else {
									throw new CDbException('user '.$u_id.' not activated for club: ' .$club_id);
								}
								
									
								$newClub = Club::model()->findByPk($club_id);
								if($newClub) {
									if(isset($newClub->url) && $newClub->url != '') {
										$club_url = $newClub->url;
										
										$length = 70;
										$chars = array_merge(range(0,9), range('a','z'), range('A','Z'), range(0,9), range('a','z'), range('A','Z'));
										shuffle($chars);
										$sessionValidationKey = implode( '', array_slice($chars, 0, $length) );
											
										$key = new ClubChangeKey; 
										$key->u_id = $u_id;
										$key->club_id = $club_id;
										$date = CTimestamp::getDate(false, false, false);
										$key->date  = date('Y-m-d G:i:s', $date[0]);
										$key->key = $sessionValidationKey;
										
										if( $key->validate() ) {
											
											$key->save();
											$transaction->commit();
											
											echo CJSON::encode(array('valid' => true, 'club_id' => $club_id,
													'clubUrl' => $club_url, 'sessionValidationKey' => $sessionValidationKey));
											return;
										}
										else {
											
											
											echo CJSON::encode(array('valid' => false, 'error' => 'validation error' ));
											return;
										}
										
									}
								}
							}
						}
						catch (Exception $e) {
							$transaction->rollback();
						}							
							
					}
				}
			}
			
			echo CJSON::encode(array('valid' => false));
			return;
		}
	}
	
	
	public function actionShowInactivePlayers() {
		
		$access = Yii::app()->user->checkAccess('club_manager');
		if(!Yii::app()->user->getIsGuest() && $access) {
			$u_id = Yii::app()->user->id;
			$clubId = Yii::app()->user->getState('club_id');
			
			$hasClubsInactive = HasClubs::model()->findAllByAttributes(array('club_id' => $clubId, 'activated' => 'false'));
			$inactivePlayers = array();
			foreach ($hasClubsInactive as $inactive) {
				$player = User::model()->findByPk($inactive->u_id);
				if($player) {
					$player->password = Null;
					$inactivePlayers[] = $player;
				}
			}
			
			$this->render('showInactivePlayers', array('inactivePlayers' => $inactivePlayers));
			return;
		}
		
		$this->redirect(Yii::app()->homeUrl);
		return;
	}
	
	
	public function actionDeleteActivationRequest($userID) {
		
		$access = Yii::app()->user->checkAccess('club_manager');
		if(!Yii::app()->user->getIsGuest() && $access) {
			// TODO
		}
	} 
		
	/**
	 * Activates the player with user id $userID.
	 * 
	 * An administrative user has to be logged in,
	 * and it's curren club needs to be the same as 
	 * the club he wants to activate the given player for.
	 * 
	 * For the player that should be activated, a 'HasClubs' 
	 * model has to exist. 
	 * 
	 * if the player already belongs to the club,
	 * nothing will happen.
	 * 
	 * @param unknown $userID
	 * @throws CDbException if above conditions do not match.
	 */
	public function actionActivatePlayer($userID = Null) {
		
		$access = Yii::app()->user->checkAccess('club_manager');
		if(!Yii::app()->user->getIsGuest() && $access) {
			
			$curr_u_id = Yii::app()->user->id;
			if($userID == Null) {
				// TODO: add possibility to process ajax requests
			}
			
			$clubId = Yii::app()->user->getState('club_id');
			
			$transaction = Yii::app()->db->beginTransaction();
			try
			{				
				$club = Club::model()->findByPk($clubId);
				if($club) {
					$user = User::model()->findByPk($userID);
					if($user) {
						$addingUserhasClub = HasClubs::model()->findByPk(array('u_id' => $curr_u_id, 'club_id' => $clubId));
						if($addingUserhasClub) {
							$hasClub = HasClubs::model()->findByPk(array('u_id' => $userID, 'club_id' => $clubId));
							if($hasClub) {								
								if(!$hasClub->activated) {
									
									$hasClub->activated = true;	
									$hasClub->role = ClubRole::AUTHOR;		
									if($hasClub->validate()) {
										$hasClub->update();
										
										$transaction->commit();
									}
									else {
										throw new CDbException('Validation error: Can not activate player '.$userID.' for club '.$clubId);
									}
								}								
								// if user already is activated, everything is fine
							}
						}
						else {
							throw new CDbException('User '.$curr_u_id.' can not add player '.$userID.' to club '.$clubId);
						}
					}
					else {
						throw new CDbException('User:  '.$userID.' does not exist.');
					}				
				}
				else {
					throw new CDbException('Club: '.$clubId.' does not exist.');
				}
			}
			catch (Exception $e) {
				$transaction->rollback();
			}
		}		
		
		$this->actionShowInactivePlayers();
		return;
	}
	
	
// 	public function actionAddToClub($userMail) {
		
// 		if(!Yii::app()->user->getIsGuest()) {
			
// 			$curr_u_id = Yii::app()->user->id;
// 			$clubId = Yii::app()->user->getState('club_id');
			
// 			$transaction = Yii::app()->db->beginTransaction();
// 			try
// 			{
// 				$user = User::model()->findAllByAttributes(array('email' => $userMail));
// 				if(empty($user)) {
// 					// TODO: create new user and assign  $userID
// 				}
// 				else {
// 					$userID = $user->u_id;
// 				} 

// 				// TODO: assert(isset($userID));
				
// 				$club = Club::model()->findByPk($clubId);
// 				if($club) {
					
// 					/*
// 					 * check if user is allowed to add another user
// 					 */
// 					$addingUserhasClub = HasClubs::model()->findByPk(array('u_id' => $curr_u_id, 'club_id' => $clubId));
// 					if($addingUserhasClub) {
// 						$hasClub = HasClubs::model()->findByPk(array('u_id' => $userID, 'club_id' => $clubId));
// 						if(!$hasClub) {
// 							/*
// 							 * add user to club and activate
// 							 */
// 							$hasNewClub = new HasClubs;
// 	                        $hasNewClub->club_id = $clubId;	
// 	                        $hasNewClub->u_id = $userID;
// 	                        $hasNewClub->activated = 1;		
// 	                        if($hasNewClub->validate()) {
// 	                        	$hasNewClub->save();
// 	                        }
// 	                        else {
// 	                        	throw new CDbException('Validation error: Can not add player '.$userID.' to club '.$clubId);
// 		                    }
// 						}
// 						else {
// 							/*
// 							 * activate user
// 							 */
// 							$hasClub->activated = 1;
// 							if($hasClub->validate()) {
// 								$hasClub->update();
// 							}
// 							else {
// 								throw new CDbException('Validation error: Can not activate player '.$userID.' for club '.$clubId);
// 							}
// 						}
// 					}
// 					else {
// 						throw new CDbException('User '.$curr_u_id.' can not add player '.$userID.' to club '.$clubId);
// 					}
// 				}
// 				else {
// 					throw new CDbException('Club '.$clubId.' does not exist.');
// 				}
				
// 				$transaction->commit();
// 			}
// 			catch (Exception $e) {
// 				$transaction->rollback();
// 			}
			
			
// 		}
		
// 	}
	
	
	
	public function actionAddPlayer() {
		$userModel = new User();
		$curr_u_id = Yii::app()->user->id;
								
		$access = Yii::app()->user->checkAccess('club_manager');
		if(!Yii::app()->user->getIsGuest() && $access) {
			
			if(isset($_POST) && isset($_POST['User'])) {
				
				$transaction = Yii::app()->db->beginTransaction();
				try
				{			
					
					$club_id = Yii::app()->user->getState('club_id');
					if(!isset($club_id) || $club_id < 0) {
						throw new CException('no club id set ');
					}	
									
					$club = Club::model()->findByPk($club_id);
					if(!isset($club)) {
						throw new CDbException('no club with id: ' .$club_id. ' exists.');
					}	

					
					$userModel->email = $_POST['User']['email'];
					$userModel->prename = $_POST['User']['prename'];
					$userModel->name = $_POST['User']['name'];
					
					// check if an email was set
					if(isset($_POST['User']['email']) && strlen($_POST['User']['email']) > 1) {

						if(!$userModel->validate(array('email'))) {
							
							throw new CDbException('Validation error for given email address: '.$userModel->email);
						}
																														
						// check if user already exists
						$tmp_user = User::model()->findByAttributes(array('email' => $userModel->email));
						if($tmp_user) {
																					
							$hasClub = HasClubs::model()->findByPk(array('u_id' => $tmp_user->u_id, 'club_id' => $club_id));
							if($hasClub) {
								/*
								 * user already exists and needs to be activated for the desired club.
								* The user already ask to get activated for the given club.
								*/			
								if(!$hasClub->activated) {
																											
									$hasClub->role = ClubRole::AUTHOR;									
									$hasClub->activated = 1;
									if($hasClub->validate()) {
											
										$hasClub->update();
										
										$transaction->commit();
										echo CJSON::encode(array('valid' => true));
										return;
									}
									else {
										throw new CDbException('Validation error: Can not activate player '.$tmp_user->u_id.' for club '.$club_id);
									}
								}
								
								$transaction->commit();	// also commit if user is already activated
								echo CJSON::encode(array('valid' => false, 'err' => 'user already exists for given club.'));		// user already exists.
								return;
							}
							else {
								/*
								 * user already exists but has not asked for activation by himself
								 * TODO: think about this case;
								 * 			A club could 'invite' many users, so they are 'spamed' with their news feed
								*/
								$hasClub = new HasClubs;
								$hasClub->u_id = $tmp_user->u_id;
								$hasClub->club_id = $club_id;
								$hasClub->activated = 1;
								$hasClub->role = ClubRole::AUTHOR;
								if($hasClub->validate()) {
									$hasClub->save();
										
									$transaction->commit();
									echo CJSON::encode(array('valid' => true));
									return;
								}
								else {
									throw new CDbException('Validation error: Can not add player '.$tmp_user->u_id.' to club '.$club_id);
								}
							}
						}
						else {
							/*
							 * user does not exist, yet.
							*/
						
							$date = CTimestamp::getDate(false, false, false);
							$userModel->reigstered_date = date('Y-m-d', $date[0]);
							$userModel->last_login = Null;
							$salt = User_Identity::blowfishSalt();
							$pw = User_Identity::createRandomPassword(5);
							$userModel->password = crypt($pw, $salt);
							$userModel->activated = 0;
						
						
							if($userModel->validate()) {
								if($userModel->save()) {
						
									$mainPropertiesModels = new UserMainProperties;
									$mainPropertiesModels->u_id = $userModel->u_id;
									$mainPropertiesModels->img_id = Null;
									$mainPropertiesModels->gender = True;
									if($mainPropertiesModels->validate()) {
										$mainPropertiesModels->save();
									}
									else {
										throw new CDbException('Validation error: can not validate UserMainProperties.');
									}
										
									$emailModels['0'] = new UserEmail;
									$emailModels['0']->u_id = $userModel->u_id;
									$emailModels['0']->visibility = Visibility::_CLUB;
									$emailModels['0']->email = $userModel->email;
									if($emailModels['0']->validate()) {
										$emailModels['0']->save();
									}
									else {
										throw new CDbException('Validation error: can not validate UserMainProperties.');
									}
						
									$hasClubs = new HasClubs;
									$hasClubs->club_id = $club_id;
									$hasClubs->u_id = $userModel->u_id;
									$hasClubs->role = ClubRole::AUTHOR;
									$hasClubs->activated = 1;
									if($hasClubs->validate()) {
										$hasClubs->save();
									}
									else {
										throw new CDbException('Validation error: can not validate UserMainProperties.');
									}
						
									$transaction->commit();
						
									// 								$dummyController = new SiteController('dummy_side_controller');
									$this->sendActivationMail('german', $userModel->email, $pw);
						
									echo CJSON::encode(array('valid' => true, 'user_created' => true));
									return;
								}
								else {
									throw new CDbException('Saving error: Can not add player '.$userModel->u_id.' to club '.$club_id);
								}
							}
							else {
								throw new CDbException('Validation error: Can not add player '.$userModel->u_id.' to club '.$club_id);
							}
						}
					}
					else { 						
						
						/*
						 * no email address set --> create user without email and 'dummy' random password
						 */
						$date = CTimestamp::getDate(false, false, false);
						$userModel->email = Null;
						$userModel->reigstered_date = date('Y-m-d', $date[0]);
						$userModel->last_login = Null;
						$salt = User_Identity::blowfishSalt();
						$dummyPw = User_Identity::createRandomPassword(10);
						$userModel->password = crypt($dummyPw, $salt);
						$userModel->activated = 1;
						
						
						if($userModel->validate()) {
							if($userModel->save()) {
						
								$mainPropertiesModels = new UserMainProperties;
								$mainPropertiesModels->u_id = $userModel->u_id;
								$mainPropertiesModels->img_id = Null;
								$mainPropertiesModels->gender = True;
								if($mainPropertiesModels->validate()) {
									$mainPropertiesModels->save();
								}
								else {
									throw new CDbException('Validation error: can not validate UserMainProperties.');
								}
						
								
// 								$emailModels['0'] = new UserEmail;
// 								$emailModels['0']->u_id = $userModel->u_id;
// 								$emailModels['0']->visibility = Visibility::_CLUB;
// 								$emailModels['0']->email = $userModel->email; // TODO: email is Null --> violates constraint
// 								if($emailModels['0']->validate()) {
// 									$emailModels['0']->save();
// 								}
// 								else {
// 									throw new CDbException('Validation error: can not validate UserMainProperties.');
// 								}
						
								$hasClubs = new HasClubs;
								$hasClubs->club_id = $club_id;
								$hasClubs->u_id = $userModel->u_id;
								$hasClubs->activated = 1;
								$hasClubs->role = ClubRole::AUTHOR;
								if($hasClubs->validate()) {
									$hasClubs->save();
								}
								else {
									throw new CDbException('Validation error: can not validate UserMainProperties.');
								}
						
								// No need to send an activation mail, due to the
								// profile does not belong to a real user.								
								$transaction->commit();

								echo CJSON::encode(array('valid' => true, 'user_created' => true));
								return;
							}
							else {
								throw new CDbException('Saving error: Can not add player '.$userModel->u_id.' to club '.$club_id);
							}
						}
						else {
							throw new CDbException('Validation error: Can not add player '.$userModel->u_id.' to club '.$club_id);
						}
					}
					
				}
				catch (Exception $e) {
					
					$transaction->rollback();	
					
					echo CJSON::encode(array('valid' => false, 'err' => $e->getMessage()));
					return;
				}				
			}
			
		}
		
		echo CJSON::encode(array('valid' => false, 'err' => 'user has no access.'));
		return;
	}
	
	/**
	 * returns all teams that belong to the club of the user
	 * who triggerd the action.
	 * @return array of Team models.
	 */
	public function getAllTeams() {
				
		$access = Yii::app()->user->checkAccess('club_manager');
		if(!Yii::app()->user->getIsGuest() && $access) {
			$u_id = Yii::app()->user->id;
			$clubId = Yii::app()->user->getState('club_id');
			
			$teams = Team::model()->findAllByAttributes(array('club_id' => $clubId));
			if(isset($teams)) {
				return $teams;
			}
		}
		
		return array();
	}
	
	/**
	 * return all the teams for the given player.
	 * Only the teams that have the same club id as the
	 * club of the user that triggered the actions are 
	 * considered.
	 * 
	 * Constraints:
	 * The triggering user needs to be activated within the
	 * system as well as for the club from which the teams 
	 * are taken.
	 * 
	 * @param unknown $playerID
	 * @return multitype:
	 */
	public function getTeams($playerID) {
		$teams = array();
		// TODO: asserts for the constraints mentioned in the description above.
		
		$access = Yii::app()->user->checkAccess('club_manager');
		if(!Yii::app()->user->getIsGuest() && $access) {
			$u_id = Yii::app()->user->id;
			$clubId = Yii::app()->user->getState('club_id');
						
			
			/*
			 * check player for whom teams should be searched
			 * belongs to the same club as the user who triggerd the 
			 * action.
			 */
			$hasClub = HasClubs::model()->findByPk(array('club_id' => $clubId, 'u_id' => $playerID));
			if(isset($hasClub) && $hasClub->activated) {
				
				/*
				 * check if player is activated within the system
				 */
				$user = User::model()->findByPk($playerID);
				if(!isset($user) || !$user->activated) {
					return array();
				}
				
				$hasTeams = HasTeams::model()->findAllByAttributes(array('u_id' => $playerID));
				$tmpTeams = array();				
				foreach ($hasTeams as $hasTeam) {
					$team = Team::model()->findByPk($hasTeam->team_id);
					if($team->club_id == $clubId) {
						$tmpTeams[] = $team;
					}
				}
				
				/*
				 * sort team list
				 */				
				while(!empty($tmpTeams)) {
					$currHighestRank = 10000;
					$currIndex = 0;
					foreach ($tmpTeams as $i => $tmpTeam) {
						if($tmpTeam->team_rank < $currHighestRank) {
							$currHighestRank = $tmpTeam->team_rank;
							$currIndex = $i;
						}
					}
					
					$teams[] = $tmpTeams[$currIndex];
					unset($tmpTeams[$currIndex]);
				}
			}
		}
		
		return $teams;
	}
	
	/**
	 * deletes a player from a club, but does not 
	 * remove him from the system.
	 */
	public function actionDeletePlayer($player_id = Null) {
	
		$access = Yii::app()->user->checkAccess('club_manager');
		if(!Yii::app()->user->getIsGuest() && $access) {
			
			$clubId = Yii::app()->user->getState('club_id');
			if(isset($player_id)) {
				
				$transaction = Yii::app()->db->beginTransaction();
				try
				{
					$hasClub = HasClubs::model()->findByPk(array('u_id' => $player_id, 'club_id' => $clubId));					
					if(isset($hasClub)) {
												
						if($hasClub->delete()) {
							
							$hasTeams = HasTeams::model()->findAllByAttributes(array('u_id' => $player_id));
							if(isset($hasTeams)) {
								foreach ($hasTeams as $hasTeam) {
									
									if(!$hasTeam->delete()) {
										throw new CDbException('cannot delete user: ' .$player_id . ' 
												from team: '.$hasTeam->team_id.'. DB Error.');
									}																		
								}								
							}

							$transaction->commit();
						}
						else {
							throw new CDbException('cannot delete user: ' .$player_id . '. DB Error.');
						}						
					}		
					else {
						throw new CDbException('no user: ' .$player_id);
					}		
				}
				catch (CException $e) {
					
					$transaction->rollback();
				}
				
				$this->redirect($this->createUrl('club/deletePlayer'));
			}
			else {
				$players = $this->getAllPlayers();
				
				$this->render('deletePlayer', array('players' => $players));
				return;
			}						
		}
	
		$this->redirect(Yii::app()->homeUrl);
	}
	
	/**
	 * 
	 * @return array of User models
	 */
	public function getAllPlayers() {
		
		$players = array(); 
		
		$access = Yii::app()->user->checkAccess('club_manager');
		if(!Yii::app()->user->getIsGuest() && $access) {
			$u_id = Yii::app()->user->id;
			$clubId = Yii::app()->user->getState('club_id');
			
			$hasClubs = HasClubs::model()->findAllByAttributes(array('club_id' => $clubId));
			if(!empty($hasClubs)) {
				foreach($hasClubs as $hasClub)
				{
					if($hasClub->activated) {
						$player = User::model()->findByPk($hasClub->u_id);
						if($player->activated) {
							$player->password = Null;
							$players[] = $player;
						}
					}					
				}
			}
		}
		
		return $players;
	}
	
	public function changeClubPrivilegesOverview() {
		// TODO:
	}
	
	public function changeClubPrivileges() {
		// TODO:
	}
	
	
	/**
	 * Sends an email with an activation link to the given email address.
	 *
	 * This method should only be called, if the user with the given mail address
	 * exists and is Not activated, yet.
	 * @param type $language
	 * @param type $recipientMail
	 * @return boolean
	 */
	private function sendActivationMail($language, $recipientMail, $pw)
	{
		
		// TODO: assert user->activated == false
		$connection=Yii::app()->db;
		/*
		 * generate activation key
		*/
		$length = 25;
		$chars = array_merge(range(0,9), range('a','z'), range('A','Z'));
		shuffle($chars);
		$activation_key = implode(array_slice($chars, 0, $length));
	
		// TODO: assert isset club_id (of session)
		$c_id = Yii::app()->user->getState('club_id');
		$tmpClub = Club::model()->findByPk($c_id);
		$clubUrl = $tmpClub->url;
		$clubName = $tmpClub->name;
		
		/**
		* get user id from user table by stating the user's email address
		*/
		$querryCommand = $connection->createCommand();
		 $querryCommand->setFrom('tbl_user');
		 $querryCommand->setWhere("email='" . $recipientMail . "'");
		 $row = $querryCommand->queryRow(true);
		 assert($row == true);
	
		 $u_id = $row['u_id'];
		 $prename = $row['prename'];
		 $name = $row['name'];
		 assert($row['activated'] == false);
		 
		/**
		* chek if an entry in the activation table already exists
		*/
 		$querryCommand2 = $connection->createCommand();
 		$querryCommand2->setFrom('tbl_user_activation');
 		$querryCommand2->setWhere("u_id='" . $u_id . "'");
 		$row2 = $querryCommand2->queryRow(true);
 		if($row2 == true)
 		{
	 		$sql = 	"UPDATE tbl_user_activation SET ".
			 		"activation_key = '".$activation_key. "', ".
			 		"date = '". "now()" ."' ".
			 		"WHERE u_id = '".$u_id."';";
	 		$connection->createCommand($sql)->execute();
		}
		else {
		// due to the above assertions we can insert a new row,
			$sql = "INSERT INTO tbl_user_activation VALUES (" .
					"'" . $u_id ."', ".
					"'" . "now()" ."', ".
					"'" . $activation_key ."'".
					");";
					$connection->createCommand($sql)->execute();
		}
	
	
		/**
		* Sending activation mail for different languages
		*/
		if($language == 'german')
		{
		$subject = 'Registrierung bei ' . Yii::app()->name;
			$content = 'Hallo ' . $prename .' '. $name .',<br><br>
			<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
					"http://www.w3.org/TR/html4/strict.dtd">
					<html>
					<body>									'.
					'
					Der Verein '.$clubName.' hat für Sie wurde ein Profil auf http://'. $clubUrl .' erstellt. <br>
					Sie können sich auf http://'. $clubUrl .' mit folgendem Passwort anmelden: <br>
					Passwort: '.$pw.'<br>	
					Dieses kann später noch abgeändert werden. <br>	  
					<br> <br>
					Bevor die Registrierung abgeschlossen werden kann, müssen Sie einen letzten Schritt machen. <br>
					<br>
					Anmerkung: Sie müssen diesen letzten Schritt machen, um Ihre Registrierung zu Ende zu führen.<br>
					 <br>
					 Um die Registrierung zu vervollständigen, müssen Sie auf diesen Link klicken:<br>'.
					 $this->createAbsoluteUrl('site/activation', array('mail' => $recipientMail, 'key' => $activation_key)). '<br>
<br>
**** Funktioniert der Link oben nicht? ****<br>
Wenn der Link nicht funktioniert, sollten Sie folgende Adresse in Ihrem Browser aufrufen:<br>'.
	$this->createAbsoluteUrl('site/activation'). '<br>
<br>
	Bitte achten Sie darauf, dass keine Leerzeichen in der Adresse sind.<br>
Wenn Sie den letzteren Link ( '. $this->createAbsoluteUrl('site/activation'). ' ) benutzt haben, <br>
müssen Sie auf der erscheinenden Seite Ihren E-Mail Adresse sowie folgenden Aktivierungscode eingeben. <br>
	<br>
	Ihr Aktivierungscode lautet:    '. $activation_key .'<br>
	<br>						'. 
'
Wollen Sie sie kein Profil auf http://'. $clubUrl .' haben, können Sie diese E-Mail ignorieren.<br>
<br>
<br>
Vielen Dank.<br>
	</body>
</html>';
	
	
			// sending the mail
                Yii::app()->mailer->send($recipientMail, $subject, $content);
                return true;
					}
					elseif($language == 'english')
            {
                // TODO: default english text
                assert($language != 'english');
                return false;
            }
	
	
      	}
      	
      	
// 	private function activatePlayer($userID) {
		
// 	}
	
}
?>