<?php

class NewsController extends Controller
{
	
	/**
	 * This is the default 'index' action that is invoked
	 * when an action is not explicitly requested by users.
	 */
	public function actionIndex()
	{
		// renders the view file 'protected/views/site/index.php'
		// using the default layout 'protected/views/layouts/main.php'
		$this->render('index');
	}
	
	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
		if($error=Yii::app()->errorHandler->error)
		{
			if(Yii::app()->request->isAjaxRequest)
				echo $error['message'];
			else
				$this->render('error', $error);
		}
	}
	
	/**
	 * This is the action to handle the current mixed tournament
	 */
	public function actionMixedCurr($page_id=-1)
	{
// 		if($error=Yii::app()->errorHandler->error)
// 		{
// 			if(Yii::app()->request->isAjaxRequest)
// 				echo $error['message'];
// 			else
// 				$this->render('mixed_curr', $error);
// 		}
		
		
		$this->render('mixed_curr', array('page_id' => $page_id));
	}
	
	
// 	public function filters()
// 	{
// 		return array(
// 				'accessControl'           // required to enable accessRules
// 		);
// 	}
	
// 	public function accessRules()
// 	{
// 		return array(
// 				array('allow', // allow readers only access to the view file
// 						'actions'=>array('newsFeed'),
// 						'roles'=>array('reader')
// 				),
				
// 				array('allow', // allow readers only access to the view file
// 						'actions'=>array('createNews'),
// 						'roles'=>array('editor', 'author')
// 				),
	
// 				array('deny',   // deny everybody else
// 						'users' => array('*')
// 				)
// 		);
// 	}
	
	
	/**
	 *
	 * @param unknown $news_id
	 */
	public function actionNewsFeed($news_id=-1, $offset=0, $clubId=Null, $clubUrl=Null) {
		$clubID = $this->getClubId($clubId, $clubUrl);
		$userClubID = Yii::app()->user->getState('club_id');
		$newsAuthors = array();
		
		$access = Yii::app()->user->checkAccess('reader');		
		if($news_id == -1) {
			$limit = 10;
			$newsModels = Null;
			if(!Yii::app()->user->getIsGuest() && $access) {
				if($userClubID == $clubID) {
					$newsModels = News::model()->findAllByAttributes(array('club_id' => $clubID), array('order'=>'date DESC', 'limit' => $limit, 'offset' => $offset));
				}
				else {
					$newsModels = News::model()->findAllByAttributes(array('club_id' => $clubID, 'visibility' => Visibility::_PUBLIC), array('order'=>'date DESC', 'limit' => $limit, 'offset' => $offset));
				}
				
				foreach($newsModels as $nn) {
					// no guest --> user will see the new's author
					if(isset($nn->u_id) && $nn->u_id>=0) {
						$author = User::model()->findByPk($nn->u_id);
						$newsAuthor = "(".$author->prename .' '. $author->name.")";
						$newsAuthors[$nn->news_id] = $newsAuthor;
					}
				}
			}
			else {
				$newsModels = News::model()->findAllByAttributes(array('club_id' => $clubID, 'visibility' => Visibility::_PUBLIC), array('order'=>'date DESC', 'limit' => $limit, 'offset' => $offset));
			}
			
			$currCount = count($newsModels);
			$newsCount = News::model()->count();
			$newsImages = array();
			foreach ($newsModels as $news) {
	
				/*
				 * cut string after a certain amount of chars
				*/
				if(!isset($news->img_id)) {
					if(strlen($news->text) > 650) {
						$news->text = substr($news->text, 0, 650);
					}
				}
				else {
					if(strlen($news->text) > 450) {
						$news->text = substr($news->text, 0, 500);
					}
				}
	
				/*
				 * cut string after a certain amount of 'PHP_EOL'
				*/
				$maxLines = 12;
				$LastOcc = strpos($news->text, PHP_EOL, 0);
				$occurrences = $LastOcc==false ?0:1;
				while($occurrences < $maxLines && ($LastOcc!= false)) {
						
					$LastOcc = strpos($news->text, PHP_EOL, $LastOcc+1);
					$occurrences = $LastOcc==false ? 0 : $occurrences+1;
				}
				if($LastOcc != false) {
					$news->text = substr($news->text, 0, $LastOcc-1);
				}
	
	
				$news->text = str_replace(PHP_EOL,"<br>",$news->text);
	
				if($news->img_id != Null) {
					$newsImage = ImageModel::model()->findByPk($news->img_id);
					if(isset($newsImage) && isset($newsImage->file_name) && file_exists($newsImage->file_name)) {
	
						/*
						 * detect if image should be scaled in width or height
						*/
						$easyImg = new EasyImage($newsImage->file_name);
						$img = $easyImg->image();
						$w = $img->width;
						$h = $img->height;
						$scaleHorz = false;
						if($w > $h) {
							$scaleHorz = true;
						}
	
						$newsImages[$news->news_id] = array('file_name' => $newsImage->file_name, 'scaleHorz' => $scaleHorz);
					}
				}
			}
				
			$this->render('newsFeed', array('newsModels' => $newsModels, 'newsAuthors' => $newsAuthors,'newsImages' => $newsImages,
					'currCount' => $currCount, 'limit' => $limit, 'offset' => $offset, 'newsCount' => $newsCount));
		}
		else {
			/*
			 * show single News
			 */
			
			
			$newsModel = News::model()->findByPk($news_id);
			if(!isset($newsModel)) {
				$this->redirect(Yii::app()->homeUrl);
			}
			
			$newsAuthor = "";
			
			/*
			 * visibility check
			 */
			$access = Yii::app()->user->checkAccess('reader');
			if(Yii::app()->user->getIsGuest()) {
				if($newsModel->visibility != Visibility::_PUBLIC) {
					$this->redirect(Yii::app()->homeUrl);
				}								
			}
			else {
				
				// no guest --> user will see the new's author
				if(isset($newsModel->u_id) && $newsModel->u_id>=0) {
					$author = User::model()->findByPk($newsModel->u_id);
					$newsAuthor = "(".$author->prename .' '. $author->name.")";
				}
				
				if((!isset($userClubID) && $userClubID != $clubID && $newsModel->visibility != Visibility::_PUBLIC) || !$access) {
					$this->redirect(Yii::app()->homeUrl);
				}
			}

			
			$newsModel->text = str_replace(PHP_EOL,"<br>",$newsModel->text);
			if($newsModel->img_id != Null) {
				$newsImage = ImageModel::model()->findByPk($newsModel->img_id);
				$images = NewsImage::model()->findAllByAttributes(array('news_id' => $news_id));
				$newsImages = array();
				$mainImg = array();
				foreach ($images as $image) {
					$tmpNewsImage = ImageModel::model()->findByPk($image->img_id);
					if(isset($tmpNewsImage) && isset($tmpNewsImage->file_name) && file_exists($tmpNewsImage->file_name)) {
						$easyImg = new EasyImage($tmpNewsImage->file_name);
						$img = $easyImg->image();
						$w = $img->width;
						$h = $img->height;
						$scaleHorz = false;
						if($w > $h) {
							$scaleHorz = true;
						}
							
						if($tmpNewsImage->img_id == $newsImage->img_id) {
							$mainImg[$tmpNewsImage->file_name] = $scaleHorz;
						}
						else {
							$newsImages[$tmpNewsImage->file_name] = $scaleHorz;
						}
					}				
				}
				$tmpNewsImgs = array_merge($mainImg, $newsImages);
				$newsImages = $tmpNewsImgs;
				
				
				if(isset($newsImage) && isset($newsImage->file_name) && file_exists($newsImage->file_name)) {
						
					/*
					 * detect if image should be scaled in width or height
					*/
					$easyImg = new EasyImage($newsImage->file_name);
					$img = $easyImg->image();
					$w = $img->width;
					$h = $img->height;
					$scaleHorz = false;
					if($w > $h) {
						$scaleHorz = true;
					}
						
					$this->render('news', array('newsModel' => $newsModel, 'newsAuthor' => $newsAuthor, 'newsImage' => $newsImage, 
							'scaleHorz' => $scaleHorz, 'newsImages' => $newsImages));
				}
				else {
					$this->render('news', array('newsModel' => $newsModel, 'newsAuthor' => $newsAuthor));
				}
			}
			else {
				$this->render('news', array('newsModel' => $newsModel, 'newsAuthor' => $newsAuthor));
			}
		}
	}
	
	public function actionCreateNews() {
	
		$updateErrorMessage = array('noErrors' => true);
		
		$isUser = (!Yii::app()->user->getIsGuest());
		$access = Yii::app()->user->checkAccess('author');		
		if($isUser && $access) {
			
			$clubID = Yii::app()->user->getState('club_id');
			$newsModel = new News;
			$image = new ImageModel;
			$newsCreated = false;
			$newsImagePath = self::$newsImagePath;
			
			// store all file names of the uploaded files in this array.
			// if any upload or a db action fails
			// all files within this array will be deleted
			$tmpUploadedFiles = array(); 
				
			if(isset($_POST['News'])) {
				$newsModel->news_id = Null;
				$newsModel->u_id = Yii::app()->user->id;
	
	
				$date = CTimestamp::getDate(false, false, false);
				$newsModel->date  = date('Y-m-d G:i:s', $date[0]);
	
				$newsModel->headline = $_POST['News']['headline'];
				$newsText = $_POST['News']['text'];
				$newsModel->text = $newsText;
				$newsModel->visibility = $_POST['News']['visibility'];	// TODO: news can not be private
				$newsModel->club_id = $clubID;
	
				if($newsModel->validate()) {
					$transaction = Yii::app()->db->beginTransaction();
					try
					{						
						$newsModel->save();
						
						$uploadedFile= CUploadedFile::getInstancesByName('file_name');
						foreach ($uploadedFile as $file) {
							
							$tmp_image = new ImageModel;
							$tmp_image->date = $newsModel->date;
							
							$length = 20;
							$chars = array_merge(range(0,9), range('a','z'), range('A','Z'));
							shuffle($chars);
							$RandFileName = implode(array_slice($chars, 0, $length));
							$RandFileName = $newsImagePath.$RandFileName. $file->name;
							$tmp_image->file_name = $RandFileName;
							$tmpUploadedFiles[] = $RandFileName;
							if($tmp_image->validate())
							{
								$fileSaved = $file->saveAs($RandFileName);
								if($fileSaved) {
									if($tmp_image->save()) {
										if ($newsModel->img_id == Null) {
											$newsModel->img_id = $tmp_image->img_id;
											
											if(!$newsModel->validate()) {
												throw new CDbException('could not save the NewsModel');
											}
										}	
	
										$newsImage = new NewsImage;
										$newsImage->news_id = $newsModel->news_id;
										$newsImage->img_id = $tmp_image->img_id;
										if($newsImage->validate()) {
											$newsImage->save();																							
										}																		
									}									
								}
								else
									throw new CHttpException('could not upload Image');
								
							}
							else 
								throw new CDbException('could not validate the ImageModel');
						}
						
						
						$newsCreated = $newsModel->update();	
						
						$transaction->commit();
					}
					catch(Exception $e) {						
						$transaction->rollback();
						
						foreach ($tmpUploadedFiles as $fileName) {
							if(file_exists($fileName)) {
								unlink($fileName);
							}	
						}						
					}
					
				}
				else {
					$updateErrorMessage = $updateErrorMessage['newsError'] = $newsModel->getErrors();
					$updateErrorMessage['noErrors'] = false;
				}
			}

			$this->render('createNews', array('newsModel' => $newsModel, /*'image' => $image,*/ 'newsCreated' => $newsCreated, 'isUser' => $isUser, 'updateErrorMessage' => $updateErrorMessage));
			return;
		}
			
		
		$this->render('newsFeed');
		return;
	}

	
	public function actionEditNewsOverview($offset=0) {
		
		$isUser = (!Yii::app()->user->getIsGuest());
		$access = Yii::app()->user->checkAccess(ClubRole::EDITOR);
		if($isUser && $access) {
		
			$limit = 10;
			$clubID = Yii::app()->user->getState('club_id');
				
			$newsModels = News::model()->findAllByAttributes(array('club_id' => $clubID),
					array('order'=>'date DESC', 'limit' => $limit, 'offset' => $offset));
			$currCount = count($newsModels);
			$newsCount = News::model()->count();
				
			foreach ($newsModels as $news) {
				/*
				 * cut string after a certain amount of chars
				*/
				$news->text = substr($news->text, 0, 200);
		
				/*
				 * cut string after a certain amount of 'PHP_EOL'
				*/
				$maxLines = 3;
				$LastOcc = strpos($news->text, PHP_EOL, 0);
				$occurrences = $LastOcc==false ?0:1;
				while($occurrences < $maxLines && ($LastOcc == true)) {
		
					$LastOcc = strpos($news->text, PHP_EOL, $LastOcc+1);
					$occurrences = $LastOcc==false ? 0 : $occurrences+1;
				}
				if($LastOcc == true) {
					$news->text = substr($news->text, 0, $LastOcc-1);
				}
		
				$news->text = str_replace(PHP_EOL,"<br>",$news->text);
			}
				
			$this->render('editNewsOverview', array('newsModels' => $newsModels, 'currCount' => $currCount,
					'limit' => $limit, 'offset' => $offset, 'newsCount' => $newsCount));
			return;
		}
		
		$this->render('newsFeed');
		return;
	}
	
	
	/**
	 * This function lets you alter the text and headline of a news post.
	 * Adding Images, deleting images or changing the main image as well 
	 * as the image order is handeld by other functions.
	 * @param string $newsId
	 * 
	 * @see actionDeleteNewsImage
	 * @see actionAddNewsImage
	 * @see actionChangeMainImage
	 */
	public function actionEditNews($newsId=Null) {
		
		if(isset($newsId)) {
			$isUser = (!Yii::app()->user->getIsGuest());
			$access = Yii::app()->user->checkAccess(ClubRole::EDITOR);
			
			if($isUser && $access) {
				
				$updateErrorMessage = '';
				
				$clubID = Yii::app()->user->getState('club_id');
				$newsModel = News::model()->findByPk($newsId);
				if($newsModel && $newsModel->club_id == $clubID) {
					
					$newsImagePath = self::$newsImagePath;
					$newsSuccessfulUpdated = false;
					
					// store all file names of the uploaded files in this array.
					// if any upload or a db action fails
					// all files within this array will be deleted
					$tmpUploadedFiles = array();
					
					
					
					
					//
					// updating of headline, news-text, date and visibility.
					//
					if(isset($_POST['News'])) {
						$newsSuccessfulUpdated = false;
								
						$date = CTimestamp::getDate(false, false, false);
						$newsModel->date  = date('Y-m-d G:i:s', $date[0]);
						$newsModel->headline = $_POST['News']['headline'];
						$newsModel->text = $_POST['News']['text'];
						$newsModel->visibility = $_POST['News']['visibility'];	// TODO: news can not be private
						
						$transaction = Yii::app()->db->beginTransaction();
						try {
							if($newsModel->validate()) {
								
							
								$uploadedFile= CUploadedFile::getInstancesByName('file_name');
								foreach ($uploadedFile as $file) {
										
									$tmp_image = new ImageModel;
									$tmp_image->date = $newsModel->date;
										
									$length = 20;
									$chars = array_merge(range(0,9), range('a','z'), range('A','Z'));
									shuffle($chars);
									$RandFileName = implode(array_slice($chars, 0, $length));
									$RandFileName = $newsImagePath.$RandFileName. $file->name;
									$tmp_image->file_name = $RandFileName;
									$tmpUploadedFiles[] = $RandFileName;
									if($tmp_image->validate())
									{
										$fileSaved = $file->saveAs($RandFileName);
										if($fileSaved) {
											if($tmp_image->save()) {
												if ($newsModel->img_id == Null) {
													$newsModel->img_id = $tmp_image->img_id;
														
													if(!$newsModel->validate()) {
														throw new CDbException('could not save the NewsModel');
													}
												}
								
												$newsImage = new NewsImage;
												$newsImage->news_id = $newsModel->news_id;
												$newsImage->img_id = $tmp_image->img_id;
												if($newsImage->validate()) {
													$newsImage->save();
												}
											}
										}
										else
											throw new CHttpException('could not upload Image');
								
									}
									else
										throw new CDbException('could not validate the ImageModel');
								}
								
							$newsModel->update();
							$transaction->commit();
							$newsSuccessfulUpdated = true;
							}
						}
						catch(Exception $e) {
							$transaction->rollback();
						}
					}
					
					
					
					
					
					
					//
					// get (main) news-image and further images from DB to display on editing page
					//
					$tmpNewsImage = ImageModel::model()->findByPk($newsModel->img_id);
					$newsImage = Null;
					$mainImgId = Null;
					if(isset($tmpNewsImage) && isset($tmpNewsImage->file_name) && file_exists($tmpNewsImage->file_name)) {
						$newsImage = new EasyImage($tmpNewsImage->file_name);
						$mainImgId = $tmpNewsImage->img_id;
					}
					$images = NewsImage::model()->findAllByAttributes(array('news_id' => $newsId));
					$newsImages = array();
					$imgIds = array();
					foreach ($images as $image) {
						$tmpNewsImage = ImageModel::model()->findByPk($image->img_id);
						if(isset($tmpNewsImage) && isset($tmpNewsImage->file_name) && file_exists($tmpNewsImage->file_name)) {
							$easyImg = new EasyImage($tmpNewsImage->file_name);
	// 						$img = $easyImg->image();		// scaling will be done in view
	// 						$w = $img->width;			
	// 						$h = $img->height;
	// 						$scaleHorz = false;
	// 						if($w > $h) {
	// 							$scaleHorz = true;
	// 						}
								
							$newsImages[] = $easyImg;
							$imgIds[] = $image->img_id;
						}
					}					
					
					$this->render('editNews', array('newsEdited' => $newsSuccessfulUpdated, 'newsModel' => $newsModel, 'newsImage' => $newsImage, 
							'newsImages' => $newsImages,'mainImgId' => $mainImgId, 'imgIds' => $imgIds, 'updateErrorMessage' => $updateErrorMessage));
					return;
				}
			}
		}
		$this->render('newsFeed');
		return;
	}

	
	/**
	 *
	 * @param string $newsId
	 * @see actionAddNewsImage
	 * @see actionEditNews
	 */
	public function actionChangeMainImage($newsId=Null) {		
		
		$isUser = (!Yii::app()->user->getIsGuest());
		$access = Yii::app()->user->checkAccess(ClubRole::EDITOR);
		if($isUser && $access) {
			$updateErrorMessage = '';
				
			$clubID = Yii::app()->user->getState('club_id');
			$newsModel = News::model()->findByPk($newsId);
			if($newsModel && $newsModel->club_id == $clubID) {
				
				$chImgId = -1;
				
				//
				// get data from ajax request
				//
				if (Yii::app()->request->isAjaxRequest) {
					
					$this->layout=false;
					header('Content-type: application/json');
					
					$chImgId = Null;
					if(isset($_POST['img_id'])) {
						$chImgId = $_POST['img_id'];
					}
					else {
						echo CJSON::encode(array('valid' => false));
						return;
					}
					
					$oldMainImageId = -1;
					
					if($newsModel->img_id == $chImgId) {
						$oldMainImageId = $chImgId;
						echo CJSON::encode(array('valid' => true, 'oldMainImageId' => $oldMainImageId));
						return;
					}
					
					$transaction = Yii::app()->db->beginTransaction();
					try
					{
						
						//
						// check if a newsImage and and Image with given image id exists
						//
						$image = ImageModel::model()->findByPk($chImgId);				
						if(isset($image)) {							
							
							$newsImage = NewsImage::model()->findByAttributes(array('news_id' => $newsId, 'img_id' => $chImgId));
							if(isset($newsImage)) {
								
								$oldMainImageId = $newsModel->img_id; 
								$newsModel->img_id = $chImgId;
								if($newsModel->validate()) {
									$newsModel->update();
									
									$transaction->commit();
								}
							}
						}
					}
					catch(Exception $e)
					{
						$transaction->rollback();
					
						echo CJSON::encode(array('valid' => false));
						return;
					}
					
					echo CJSON::encode(array('valid' => true, 'oldMainImageId' => $oldMainImageId));
					return;
				}
			}
		}
	
		$this->render('newsFeed');
		return;
	}
	
	
	/**
	 * 
	 * @param string $newsId
	 * @see actionAddNewsImage
	 * @see actionEditNews
	 */
	public function actionDeleteNewsImage($newsId=Null) {
	
		$isUser = (!Yii::app()->user->getIsGuest());
		$access = Yii::app()->user->checkAccess(ClubRole::EDITOR);
		if($isUser && $access) {
			$updateErrorMessage = '';
			
			$clubID = Yii::app()->user->getState('club_id');
			$newsModel = News::model()->findByPk($newsId);
			if($newsModel && $newsModel->club_id == $clubID) {
				
				$delImgId = -1;
				$delImg = Null;				// path + filename
				$newMainImageId = -1;
				
				//
				// get data from ajax request
				//
				if (Yii::app()->request->isAjaxRequest) {
					$this->layout=false;
					header('Content-type: application/json');
					
					if(isset($_POST['img_id'])) {
						$delImgId = $_POST['img_id'];
					}
					else {
						echo CJSON::encode(array('valid' => false));
						return;
					}
					
					
					$transaction = Yii::app()->db->beginTransaction();
					try
					{
						$delError = '';
					
						//
						// get (main) news-image and further images from DB
						//
						$changeMainImage = false;
						if($delImgId == $newsModel->img_id) {
							
							$changeMainImage = true;
							// change news image id, so the DB will not delete the whole news and
							$newsModel->img_id = Null;
							if($newsModel->validate()) {
								$newsModel->update();
							}
							else {
								throw new CDbException('Error while validating newsModel.');
							}
							
							$mainImage = ImageModel::model()->findByPk($delImgId);
							if(isset($mainImage)) {
								if(isset($mainImage->file_name) && file_exists($mainImage->file_name)) {
									$delImg = $mainImage->file_name;
								}
								
								// delete image and corresponding news image from DB
								$mainImage->delete();
								$images = NewsImage::model()->findAllByAttributes(array('news_id' => $newsId, 'img_id' => $delImgId));
								foreach ($images as $image) {
									$image->delete();
								}
							}
						}
						
						
						$images = NewsImage::model()->findAllByAttributes(array('news_id' => $newsId));
						foreach ($images as $image) {
							
							if($changeMainImage) {
								//
								// main image will be changed
								//
								$tmpImage = ImageModel::model()->findByPk($image->img_id);
								if(isset($tmpImage)) {
									$newsModel->img_id = $image->img_id;
									if($newsModel->validate()) {
										$newsModel->update();
										$newMainImageId = $newsModel->img_id;
										break;
									}
									else {
										throw new CDbException('Error while validating newsModel.');
									}
								}
							}
							else {
								//
								// image that is not the main news image will be deleted
								//
								if($image->img_id == $delImgId) {
									$tmpNewsImage = ImageModel::model()->findByPk($image->img_id);
									if(isset($tmpNewsImage) && $tmpNewsImage->img_id == $delImgId) {
										if(isset($tmpNewsImage->file_name) && file_exists($tmpNewsImage->file_name)) {
											$delImg = $tmpNewsImage->file_name;
										}
									
										$tmpNewsImage->delete();
										$image->delete();
									}
									
									break;
								}						
							}
						}
						
						$transaction->commit();
					}
					catch(Exception $e)
					{
						$transaction->rollback();
						
						echo CJSON::encode(array('valid' => false, 'error' => $delError));
						return;
					}
					
					
					// delete image from HD
					if(isset($delImg)) {
						unlink($delImg);
					}
					
					echo CJSON::encode(array('valid' => true, 'newMainImageId' => $newMainImageId));
					return;
				}
			}
		}	
		
		$this->render('newsFeed');
		return;
	}
	
	
	/**
	 * 
	 * @param string $newsId
	 * @see actionDeleteNewsImage
	 * @see actionEditNews
	 */
	public function actionAddNewsImage($newsId=Null) {
	
		$isUser = (!Yii::app()->user->getIsGuest());
		$access = Yii::app()->user->checkAccess(ClubRole::EDITOR);
		if($isUser && $access) {
			$updateErrorMessage = '';
			
			$clubID = Yii::app()->user->getState('club_id');
			$newsModel = News::model()->findByPk($newsId);
			if($newsModel && $newsModel->club_id == $clubID) {
				// TODO: implement
			}
		}
	
		$this->render('newsFeed');
		return;
	}
	
	
	public function actionDeleteNewsOverview($offset=0) {
		
		$isUser = (!Yii::app()->user->getIsGuest());
		$access = Yii::app()->user->checkAccess(ClubRole::EDITOR);
		if($isUser && $access) {
				
			$limit = 10;
			$clubID = Yii::app()->user->getState('club_id');
			
			$newsModels = News::model()->findAllByAttributes(array('club_id' => $clubID), 
					array('order'=>'date DESC', 'limit' => $limit, 'offset' => $offset));
			$currCount = count($newsModels);
			$newsCount = News::model()->count();
			
			foreach ($newsModels as $news) {			
				/*
				 * cut string after a certain amount of chars
				*/
				$news->text = substr($news->text, 0, 200);
				
				/*
				 * cut string after a certain amount of 'PHP_EOL'
				*/
				$maxLines = 3;
				$LastOcc = strpos($news->text, PHP_EOL, 0);
				$occurrences = $LastOcc==false ?0:1;
				while($occurrences < $maxLines && ($LastOcc == true)) {
				
					$LastOcc = strpos($news->text, PHP_EOL, $LastOcc+1);
					$occurrences = $LastOcc==false ? 0 : $occurrences+1;
				}
				if($LastOcc == true) {
					$news->text = substr($news->text, 0, $LastOcc-1);
				}				
				
				$news->text = str_replace(PHP_EOL,"<br>",$news->text);
			}
			
			$this->render('deleteNews', array('newsModels' => $newsModels, 'currCount' => $currCount, 
					'limit' => $limit, 'offset' => $offset, 'newsCount' => $newsCount));
			return;
		}
		
		$this->render('newsFeed');
		return;
	}
	
	public function actionDeleteNews($newsId=Null) {
		
		$isUser = (!Yii::app()->user->getIsGuest());
		$access = Yii::app()->user->checkAccess(ClubRole::EDITOR);
		if($isUser && $access) {
			if(isset($newsId)) {
				$clubID = Yii::app()->user->getState('club_id');
				
				$transaction = Yii::app()->db->beginTransaction();
				try
				{
					$news = News::model()->findByPk($newsId);
					if(isset($news) && $news->club_id == $clubID) {
						
						// TODO: also delete all corresponding NewsImages and all 
						// corresponding images on Disk.
						
						if($news->delete()) {
							
							$transaction->commit();
							$this->actionDeleteNewsOverview();
							return;
						}
						else {
							throw new CDbException('DB error: can not delete news with id: ' . $newsId . '.');
						}
					}
					else {
						throw new CDbException('news with id: ' . $newsId . 'not found. ');
					}
				}
				catch(Exception $e) {
					$transaction->rollback();
				
				}		
			}
		}
		
		$this->render('newsFeed');
		return;
	}
}
?>