<?php

class SiteController extends Controller
{
   
    
	/**
	 * Declares class-based actions.
	 */
	public function actions()
	{
		return array(
			// captcha action renders the CAPTCHA image displayed on the contact page 
			'captcha'=>array(
				'class'=>'CCaptchaAction',
				'backColor'=>0xFFFFFF,
			),
			// page action renders "static" pages stored under 'protected/views/site/pages'
			// They can be accessed via: index.php?r=site/page&view=FileName
			'page'=>array(
				'class'=>'CViewAction',
			),
		);
	}

	/**
	 * This is the default 'index' action that is invoked 
	 * when an action is not explicitly requested by users. 
	 */
	public function actionIndex()
	{

		$this->forward('news/newsFeed', true);
	}
	
	
	public function actionTest($par_1 = Null)
	{
	
		if($par_1 != Null) {
// 			$this->forward('site/fbRegister', true);
			
			$this->render('fbRegister',array('register' => true, 'user_mail' => $par_1, 'registerErrors' => array()));
			return;
		}
		$this->forward('news/newsFeed', true);
	}
	

	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
		if($error=Yii::app()->errorHandler->error)
		{
			if(Yii::app()->request->isAjaxRequest)
				echo $error['message'];
			else
				$this->render('error', $error);
		}
	}

	/**
	 * 
	 */
	public function actionClubAdministration() {
		
		$access = Yii::app()->user->checkAccess('editor');
		$isUser = (!Yii::app()->user->getIsGuest() && $access);
		if($isUser) {
			
			$teamModel = new Team;
			$userModel = new User;
			$subPageModel = new SubPage;
			
			$u_id = Yii::app()->user->id;
			
			
			if (Yii::app()->request->isAjaxRequest) {
				
				if(isset($_POST['Team'])) {
					$this->layout=false;
					header('Content-type: application/json');
					$teamModel->team_name = $_POST['Team']['team_name'];
					
					$validTeam = $teamModel->validate();
					if($validTeam) {	
						$club_id = Yii::app()->user->getState('club_id');
						$teamModel->club_id = $club_id;
						
						/*
						 * check if user really belongs to the given club
						 */
						$hasClub = HasClubs::model()->exists('u_id='.$u_id.'AND club_id='.($club_id));
						if($hasClub) {
							$teamModel->save();
						}						
					}
					
					// TODO: send valid = false here; valid = true above after saving ???
					echo CJSON::encode(array('valid' => $validTeam, 'teamModel' => $teamModel, 
							'subPageModel' => $subPageModel));					
					return;
				}

				if(isset($_POST['User'])) {
					
					echo CJSON::encode(array('valid' => $validTeam));
					return;
				}
				
			}
									
			
			$this->render('clubAdministration', array('teamModel' => $teamModel, 'userModel' => $userModel, 
					'subPageModel' => $subPageModel));
			return;
		}
		else {
// 			$this->render('index');
			$this->redirect(Yii::app()->homeUrl);
		}		
	}
	
	/**
	 * Displays the contact page
	 */
	public function actionContact()
	{
		$model=new ContactForm;
		if(isset($_POST['ContactForm']))
		{
			$model->attributes=$_POST['ContactForm'];
			if($model->validate())
			{
				$name='=?UTF-8?B?'.base64_encode($model->name).'?=';
				$subject='=?UTF-8?B?'.base64_encode($model->subject).'?=';
				$headers="From: $name <{$model->email}>\r\n".
					"Reply-To: {$model->email}\r\n".
					"MIME-Version: 1.0\r\n".
					"Content-type: text/plain; charset=UTF-8";

				mail(Yii::app()->params['adminEmail'],$subject,$model->body,$headers);
				Yii::app()->user->setFlash('contact','Thank you for contacting us. We will respond to you as soon as possible.');
				$this->refresh();
			}
		}
		$this->render('contact',array('model'=>$model));
	}

	/**
	 * Displays the login page
         * moved to TopBar Widget
	 */
        /*
	public function actionLogin()
	{
		$model=new LoginForm;

		// if it is ajax validation request
		if(isset($_POST['ajax']) && $_POST['ajax']==='login-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}

		// collect user input data
		if(isset($_POST['LoginForm']))
		{
			$model->attributes=$_POST['LoginForm'];
			// validate user input and redirect to the previous page if valid
			if($model->validate() && $model->login())
				$this->redirect(Yii::app()->user->returnUrl);
		}
		// display the login form
		$this->render('login',array('model'=>$model));
	}
        */
        
        /**
	 * Performs a Login with the help of facebook.
         * A User who has connected his facebook profile with the
         * page (and it's database), can simply login by calling
         * this method.
         * Yii::app()->user->getIsGuest() will return true afterwards.
         * No matter if the login was okay or not, the user will be
         * redirected to the start/index page.
	 */
	public function actionFacebookLogin($clubId=Null, $clubUrl=Null)
	{           
		
		
            if(Yii::app()->user->getIsGuest())
            {
            	$clubID = $this->getClubId($clubId, $clubUrl);
                $userIdentity = new User_Identity(Null, Null);
                $FbUserId = Yii::app()->facebook->getUser();           
                $userIdentity->useFacebookId($FbUserId);
                $userIdentity->useClub($clubID);

                /*
                 * redirect to registration site if there is no user with corresponding facebook id
                 */
                $connection=Yii::app()->db;  
                $querryCommand = $connection->createCommand();
                $querryCommand->setFrom('tbl_facebook');
                $querryCommand->setWhere("f_id='" . $FbUserId . "'");
                $row = $querryCommand->queryRow(true);
                if($row != true)
                {             
                    $registered = false;
                    $registerErrors = array();
                    $userMail = Null; 
                    $this->render('fbRegister',array('register' => $registered, 'user_mail' => $userMail, 'registerErrors' => $registerErrors));
                    
                    return;
                }
                
                /*
                 * Login user
                 */                    
                $authReturn = $userIdentity->authenticate() ;
                if($authReturn == CUserIdentity::ERROR_NONE)
                {
                    /*
                     * store login date within DB
                     */
                    $connection=Yii::app()->db;  
                    $sql =  "UPDATE tbl_user SET ".
                            "last_login = '". "now()" ."' ".
                            "WHERE u_id = '".$userIdentity->username."';";                  
                    $connection->createCommand($sql)->execute();
                    
                    Yii::app()->user->login($userIdentity);                    
                }
                else {
                    $this->render('loginError', array('error' => $authReturn));
                    return;
                }
            }
            
            
            $redirectUrl = $this->createUrl('news/newsFeed', array('news_id' => -1));
            $this->redirect($redirectUrl);
	}
        
        /**
         * Called if a login via top-bar fails
         * @param type $error CUserIdentity or User_Identity error codes
         */
        public function actionLoginError($error)
        {            
            $this->render('loginError', array('error' => $error));
        }


        /**
	 * Logs out the current user and redirect to homepage.
	 */
	public function actionLogout()
	{		
		/*
		 * remove ClubRoles 
		 */
// 		$assigned_roles = Yii::app()->authManager->getRoles(Yii::app()->user->id);
// 	    if(!empty($assigned_roles))
// 	    {
// 	        $auth=Yii::app()->authManager; 
// 	        foreach($assigned_roles as $n=>$role)
// 	        {
// 	            if($auth->revoke($n,Yii::app()->user->id)) //remove each assigned role for this user
// 	                Yii::app()->authManager->save();
// 	        }
// 	    }
		User_Identity::removeRolePrivilidges(Yii::app()->user->id);		// TODO: check if user is logged in
	 
	    Yii::app()->user->logout(); //logout the user
	    $this->redirect(Yii::app()->homeUrl); //redirect the user
	}
        
        /**
         * activates a registered user if he isn'T already activated
         */
        public function actionActivation()
        {
            $activated = false;
            $activationSuccessful = false;
            $activationExpired = false;
            $wrongActivationKey = false;
            
            if(isset($_GET['mail']))
            {
                $connection=Yii::app()->db;
                
                /**
                 * check if user exists in DB
                 */
                $querryCommand = $connection->createCommand();
                $querryCommand->setFrom('tbl_user');
                $querryCommand->setWhere("email='" . $_GET['mail'] . "'");
                $row = $querryCommand->queryRow(true);
                if($row == true)
                {
                    $activated = $row['activated'];
                    $u_id = $row['u_id'];
                    
                    if(isset($_GET['key']))
                    {  
                        /**
                         * get activation key from database for obtained user id
                         */
                        $querryCommand = $connection->createCommand();
                        $querryCommand->setFrom('tbl_user_activation');
                        $querryCommand->setWhere("u_id='" . $u_id . "'");
                        $row = $querryCommand->queryRow(true);
                        $storedKey = $row['activation_key'];
                        $activationDate = $row['date'];
                        
                        
                        $expTime = new DateTime($activationDate);
                        $expTime = $expTime->add(new DateInterval('PT48H'));
                        $nowTime = new DateTime();    
                        $nowTime->setTimezone(new DateTimeZone(date_default_timezone_get()));
                        if($nowTime > $expTime) 
                        {
                            /*
                             * activation key expired --> send new activation mail
                             */
                            if(!$activated)
                            {         
                                $activationExpired = true;
                                $this->sendActivationMail('german', $_GET['mail']);   // user exists and ist NOT activated                                     
                            }                            
                        }
                        else 
                        {
                            if($storedKey == $_GET['key'])
                            {
                                $transaction=$connection->beginTransaction();
                                try
                                {
                                    $sql = "UPDATE tbl_user SET activated = 'true' WHERE u_id = '".$u_id."';";
                                    $connection->createCommand($sql)->execute();

                                    $sql = "DELETE FROM tbl_user_activation WHERE u_id = '".$u_id."';";
                                    $connection->createCommand($sql)->execute();

                                    $transaction->commit();                                    
                                    $activationSuccessful = true;
                                    $activated = true;
                                }
                                catch(Exception $e)
                                {
                                    $transaction->rollback();
                                    $activationSuccessful = false;
                                }                               
                                
                            }
                            else {
                                $wrongActivationKey = true;
                            }
                        }                            
                    }
                    else 
                    {
                        if(!$activated)
                        {                    
                            $this->sendActivationMail('german', $_GET['mail']);   // user exists and ist NOT activated                                     
                        }
                    }                
                }
                else {
                    // mail address not in database
                    $activationSuccessful = false;
                    $activated = true;
                }
            }        
            else {
                /**
                 * GET variable has neither a key nor a mail address
                 * same as:  mail address not in system, above
                 */
                $activationSuccessful = false;
                $activated = false;
                $_GET['mail'] = '';
            }
            
            $this->render('activation',array('user_mail' => $_GET['mail'], 'activated' => $activated, 'activationSuccessful' => $activationSuccessful, 'activationExpired' => $activationExpired, 'wrongActivationKey' => $wrongActivationKey));           
        }
        
        /**
	 * Displays the register page
	 */
	public function actionFbRegister()
	{               
            
            // $model = new User;
            $registered = false;
            $saved = false;
            $registerErrors = array();
            $userMail = Null;                                                
            
            if ($_POST) {    
                $response = Yii::app()->facebook->getSignedRequest();
                
                if($response == Null)
                {
                    // Bad signed_request:
//                     echo "Es ist ein Fehler während der Übertragung aufgetreten!";
                }        
                else {
                    $login_data = $response['registration'];   

                    
                    // extract prename and name from name-field delivered by facebook
                    $name  = $login_data['name'];
                    $splitName = explode(" ", $name);
                    $i=0;
                    $prename = $splitName[$i];        
                    for($i=1; $i<count($splitName)-1; $i++)
                    {            
                       $prename = $prename ." ". $splitName[$i];
                    }   
                    
                    // create and save new user
                    // validation rules are defined within the User class
                    $user = new User;
                    $user->email = $login_data['email'];
                    $user->prename = $prename;
                    $user->name = $splitName[count($splitName)-1];
                    $date = CTimestamp::getDate(false, false, false);
                    $user->reigstered_date = date('Y-m-d', $date[0]);
                    $user->last_login = Null;        
                    $salt = User_Identity::blowfishSalt();             
                    $user->password = crypt($login_data['password'], $salt);
                    $user->activated = false;              
                         
                    if(strlen($user->password) < 13) {
                    	// TODO: crypt was not successfull
                    }
                    
                    if($user->validate()) {
	                    $connection=Yii::app()->db;
	                    $transaction=$connection->beginTransaction();
	                    try
	                    {                     	
	                    	
	                        /*
	                         * check if email already exists
	                         */
	                        $querryCommand = $connection->createCommand();
	                        $querryCommand->setFrom('tbl_user');                          
	                        $querryCommand->setWhere("email='" . $user->email . "'"); 
	                        $row = $querryCommand->queryRow(true);  
	                        if($row == true)
	                        {	                        		                        	
	                        	$clubID = $this->getClubId(Null, $_GET['clubUrl']);
	                        	if(isset($clubID) && $clubID > 0) {
	                        		
	                        		$hasClubs = HasClubs::model()->findByPk(array('u_id' => $row['u_id'], 'club_id' => $clubID));
	                        		if(isset($hasClubs)) {
	                        			// TODO: refactor message to view
	                        			$registerErrors = array('email' => array('Die Email-Adresse ist bereits im System hinterlegt.<br>
	                        			Sollten Sie ihr Passwort vergessen haben, oder sollte der Verein für Sie ein Profil erstellt haben, können 
	                        			Sie ihr Passwort mit einem Klick auf "Passwort vergessen" anfordern.'));
	                        			$saved = false;
	                        			throw new Exception('User already exists');
	                        		}
	                        		else {
	                        			$hasClubs = new HasClubs;
	                        			$hasClubs->club_id = $clubID;
	                        			$hasClubs->u_id = $user->u_id;
                                        $hasClubs->activated = 0;
//                                        $hasClubs->activated = 1;              
 	                                	  $hasClubs->role = ClubRole::COMMENTOR;
//                                        $hasClubs->role = ClubRole::ADMIN;		
	                        			if($hasClubs->validate()) {
	                        				$hasClubs->save();
	                        				
	                        				$transaction->commit();
	                        			}
	                        			else {
	                        				throw new CDbException('Fehler beim anlegen von Benutzerdaten.');
	                        			}	
	                        		}	                        		
	                        	}
	                        	else {
	                        		throw new CDbException('Can not resolve Club Url.');
	                        	}	                        	
	                        	
	                        }
	                        else 
	                        {                 
	                            
	                            /*
	                             * create user in user table
	                             */
	                            $sql = "INSERT INTO " . $user->tableName() . "(" .
	                                    "email, ".
	                                    "prename, ".
	                                    "name, ".
	                                    "reigstered_date, ".
	                                    "activated, ".
	                                    "password".
	                                    ") VALUES (" . 
	                                    "'" . $user->email ."', ".
	                                    "'" . $user->prename ."', ".
	                                    "'" . $user->name ."', ".
	                                    "'" . $user->reigstered_date ."', ".
	                                    "'" . ($user->activated ? 'true' : 'false') ."', ".
	                                    "'" . $user->password ."'".
	                                    ");";                        
	                            $connection->createCommand($sql)->execute();
	
	                                                        
	                            /*
	                             * get user id from user table
	                             */                        
	                            $querryCommand = $connection->createCommand();
	                            $querryCommand->setFrom('tbl_user');
	                            $querryCommand->setWhere("email='" . $user->email . "'");
	                            $row = $querryCommand->queryRow(true); 
	                            $userCreated = $row;
	                            if($userCreated) {
	                                $user->u_id = $row['u_id'];
	                                $userMail = $user->email;      // used for later activation
	                                
	                                /*
	                                 * add entry in facebook table
	                                 */
	                                if(array_key_exists('user_id', $response))
	                                {
	                                    $fb_userId = $response['user_id'];
	                                    
	                                    /*
	                                     * check if user already exists.
	                                     * otherwise user can register with system (via FB), change it's mail address
	                                     * and register again with the same FB-ID 
	                                     */
	                                    $querryCommand = $connection->createCommand();
	                                    $querryCommand->setFrom('tbl_facebook');
	                                    $querryCommand->setWhere("f_id='" . $fb_userId . "'");
	                                    $row = $querryCommand->queryRow(true); 
	                                    
	                                    if($row == false) {
	                                        $sql = "INSERT INTO tbl_facebook VALUES (" . 
	                                        "'" . $user->u_id ."', ".
	                                        "'" . $fb_userId ."'".
	                                        ");";
	                                        $connection->createCommand($sql)->execute();
	                                    }
	                                    else {                                        
	                                        
	                                        $registerErrors = array('fbExists' => array('Es scheint, als ob Sie bereits registriert wären!'));
	                                        $saved = false;
	                                        throw new Exception('User already exists as Facebook-User');
	                                    }                                                                
	                                }
	                                
	                                
	                                /*
	                                 * user propertie models
	                                 * (main properties, phone, email, address ...)
	                                 * 
	                                 */
	                                $mainPropertiesModels = new UserMainProperties;
	                                $mainPropertiesModels->u_id = $user->u_id;
	                                $mainPropertiesModels->img_id = Null;
	                                $mainPropertiesModels->gender = True;
	                                if($mainPropertiesModels->validate()) {
	                                	$mainPropertiesModels->save();
	                                }
	                                else {
	                                	throw new CDbException('Fehler beim anlegen von Benutzerdaten.');
	                                }
	                                
	                                $emailModels['0'] = new UserEmail;
	                                $emailModels['0']->u_id = $user->u_id;
	                                $emailModels['0']->visibility = Visibility::_CLUB;
	                                $emailModels['0']->email = $user->email;
	                                if($emailModels['0']->validate()) {
	                                	$emailModels['0']->save();
	                                }
	                                else {
	                                	throw new CDbException('Fehler beim anlegen von Benutzerdaten.');
	                                }
	                                
	                                $clubID = $this->getClubId(Null, $_GET['clubUrl']);
	                                if(isset($clubID) && $clubID > 0) {
	                                	$hasClubs = new HasClubs;
	                                	$hasClubs->club_id = $clubID;
	                                	$hasClubs->u_id = $user->u_id;
	                                	$hasClubs->activated = 0;
//                                        $hasClubs->activated = 1;               
 	                                	$hasClubs->role = ClubRole::COMMENTOR;
//	                                	$hasClubs->role = ClubRole::ADMIN;		
	                                	if($hasClubs->validate()) {
	                                		$hasClubs->save();
	                                	}
	                                	else {
	                                		throw new CDbException('Validation of HasClub Relation faild: ');
	                                	}	
	                                }
	                                
	                                $transaction->commit();
	                                $saved = true;
	                            }
	                            else {
	                                
	                                $registerErrors = array('coud_not_create_user' => array('Ihr Profil konnte nicht erstellt werden.<br>Bitte versuchen sie es erneut!'));                                
	                                $saved = false;
	                                throw new Exception('User was not created properly!');
	                            }                                   
	                                                        
	                        }
	                    }
	                    catch(Exception $e) // an exception is raised if a query fails
	                    {
	                    	$registerErrors = array('registration_error' => $e->getMessage());
// 	                    	$registerErrors = array('registration_error' => 'Fehler beim anlegen von Benutzerdaten.');
	                        $transaction->rollback();
	                        $saved = false;
	                    }
                    }
                    else {
                    	
                    	$err = $user->getErrors();
                    	if(isset($err)) {
                    		if(isset($err['email'])) {
                    			$registerErrors = $err; 
//                     			$registerErrors = array('email' => array('Die Email-Adresse ist bereits im System hinterlegt.'));
                    			$saved = false;
                    			$registered = false;
                    		}
                    	}
                    }
                    
                    
                    if($saved)
                    {
                        $registered = true;                                                 
                    }
                    else {
                        
                    }
                }
            }                        
            
            if($registered)
            {                                 
            	$redirectUrl = $this->createUrl('site/activation', array('mail' => $userMail));
            	$this->redirect($redirectUrl);
//                 $this->redirect(Yii::app()->homeUrl.'/?r=site/activation&mail='.$userMail);
            }
            else { 
                $this->render('fbRegister',array('register' => $registered, 'user_mail' => $userMail, 'registerErrors' => $registerErrors));
            }
        }    
                        
        
        /**
         * shows the password recovery site where a link can be send
         * via email. This link consists of a key that guarantees a user's
         * identity and redirects th user to another site where he can change his
         * password.
         */
         public function actionPasswordRecovery() {
             
             $mailSend = false;
             if(isset($_GET['mail']))
             {                 
                $connection=Yii::app()->db;
                /*
                 * get user ID for stated mail
                 * and checck if user exists.
                 */                                                        
                $querryCommand = $connection->createCommand();
                $querryCommand->setFrom('tbl_user');
                $querryCommand->setWhere("email='" . $_GET['mail'] . "'");
                $row = $querryCommand->queryRow(true);
                if($row == true)
                {    
                   /*
                    * send recovery site key
                    */
                    $this->sendNewPasswordMail('german', $_GET['mail']);
                }
                
                /*
                 * no matter if a user exists of not the same 
                 * output shoul always be generated due to security reasons.
                 */
                $mailSend = true;                
             }
             
             $this->render('passwordRecovery', array('mailSend' => $mailSend));
         }
         
         /**
          * 
          */
         public function actionGenNewPassword() {
                   
             $passwordChanged = false;
             $passwordsMatch = false;
             $passwordsSet = false;
             $siteVerified = false;
             $passwordToShort = true;
             $pwMinLength = 8;
             $connection=Yii::app()->db;
             
             if(isset($_GET['mail']))
             {                
                if(isset($_GET['siteKey']))
                {                    
                    /*
                     * get user ID for stated mail
                     * and checck if user exists.
                     */                                                        
                    $querryCommand = $connection->createCommand();
                    $querryCommand->setFrom('tbl_user');
                    $querryCommand->setWhere("email='" . $_GET['mail'] . "'");
                    $row = $querryCommand->queryRow(true);
                    if($row == true)
                    {
                        $u_id = $row['u_id'];

                        /*
                         * get key and date from tbl_pw_recovery for given user id
                         */
                        $querryCommand2 = $connection->createCommand();
                        $querryCommand2->setFrom('tbl_pw_recovery');
                        $querryCommand2->setWhere("u_id='" . $u_id . "'");
                        $row2 = $querryCommand2->queryRow(true);
                        if($row2 == true) {
                            $date = $row2['date'];
                            $recovery_key = $row2['recovery_key'];
                            
                            /*
                             * compare keys 
                             */
                            if($recovery_key == $_GET['siteKey']) {
                                
                                $expTime = new DateTime($date);
                                $expTime = $expTime->add(new DateInterval('PT12H'));
                                $nowTime = new DateTime();
                                $nowTime->setTimezone(new DateTimeZone(date_default_timezone_get()));                                
                                if($nowTime < $expTime) {
                                    if(isset($_POST['newPw']) && isset($_POST['newPw2'])) {
                                        $passwordsSet = true;
                                        if($_POST['newPw'] == $_POST['newPw2']) {                                                                                                                                  
                                            $passwordsMatch = true;       
                                            
                                            if(strlen($_POST['newPw']) >= $pwMinLength) {
                                                $passwordToShort = false;
                                                
                                                $transaction=$connection->beginTransaction();
                                                try
                                                {
                                                    /*
                                                     * crypt password and store new password in DB
                                                     */
                                                    $newPs = crypt($_POST['newPw'], User_Identity::blowfishSalt());

                                                    $sql = "UPDATE tbl_user SET password = '".$newPs."' WHERE u_id = '".$u_id."';";
                                                    $connection->createCommand($sql)->execute();

                                                    $sql = "DELETE FROM tbl_pw_recovery WHERE u_id = '".$u_id."';";
                                                    $connection->createCommand($sql)->execute();

                                                    $transaction->commit();
                                                    $passwordChanged = true;
                                                }
                                                catch(Exception $e) // an exception is raised if a query fails
                                                {
                                                    $transaction->rollback();
                                                    $passwordChanged = false;
                                                } 
                                            }                                                                                           
                                        }
                                    }       
                                            
                                    $mail = $_GET['mail'];
                                    $key = $_GET['siteKey'];
                                    $siteVerified = true;                                    
                                }
                            }   
                        }
                    }
                }
             }
            
             if($siteVerified)
             {
                 $this->render('genNewPassword', array('mail' => $mail, 'siteKey' => $key, 'passwordChanged' => $passwordChanged, 
                     'passwordsMatch' => $passwordsMatch, 'passwordsSet' => $passwordsSet, 'passwordToShort' => $passwordToShort, 
                     'pwMinLength' => $pwMinLength));
             }
             else {
                 $this->render('index');
             }             
         }

        
         
         
         
         
         
         
         
         
         
         //////////
         
         public function actionTraining() {
         
         
         	$this->render('training');
         }
         
         public function actionLocation() {
         
         
         	$this->render('location');
         }
         
         public function actionVereinsmeister() {
         	
         	
         	$this->render('vereinsmeister');
         }
         
         public function actionMixed() {
         
         
         	$this->render('mixed');
         }
         
         public function actionBilder_chronik() {
         
         
         	$this->render('bilder_chronik');
         }
          
         public function actionFuenfzigjahre() {
         	 
         	 
         	$this->render('fuenfzigjahre');
         }
          
         public function actionHof() {
         	 
         	 
         	$this->render('hof');
         }
         
         public function actionImpressum() {
         	 
         	 
         	$this->render('impressum');
         }
         
                  
         
         //////////
         
         
         
     public function actionParseTTS($u_id) {
	
     	$ttsParser = new scoreServiceParserTableTennisTts;
     	
     	$ttProp =  TableTennisProperties::model()->findByAttributes(array('u_id' => $u_id));
     	if(isset($ttProp) && isset($ttProp->score_service_link)) {
     		$serviceLink = $ttProp->score_service_link;
     		
     		$res = $ttsParser->parseTTS($serviceLink);
     		if(isset($res)) {
     			$tts = $res['tts'];
     			$evaluated_games= $res['evaluated_games'];
     			 
     			$scoreService =  TableTennisScoreServiceTts::model()->findByAttributes(array('u_id' => $u_id));
     			if(empty($scoreService)) {
     				$scoreService = new TableTennisScoreServiceTts;
     				$scoreService->u_id = $u_id;
     				if($scoreService->validate()) {
     					$scoreService->save();
     				}
     				else {
     					throw new CDbException('Fehler beim anfragen/anlegen von tts-daten.');
     				}
     			}
     			 
     			$scoreService->tts = $tts;
     			$scoreService->evaluated_games = $evaluated_games;
     			$date = CTimestamp::getDate(false, false, false);
     			$scoreService->last_update = date('Y-m-d G:i:s', $date[0]);
     			 
     			if($scoreService->validate()) {
     				$scoreService->update();
     			}
     			else {
     				throw new CDbException('Fehler beim aktualisieren von tts-daten.');
     			}
     		}
     		else {
     			$this->render('error');
     		}	
     	}
     	
     	$this->render('impressum');
     }     
         
         
         
         
         
         
         
         
         
         
         

//         /**
//          * 
//          * @param type $view
//          * @param type $output
//          * @return boolean
//          */
//         protected function afterRender($view, &$output) {
//         	// TODO: reused in several controller --> refactor
//             parent::afterRender($view,$output);
//             //Yii::app()->facebook->addJsCallback($js); // use this if you are registering any $js code you want to run asyc
//             Yii::app()->facebook->initJs($output); // this initializes the Facebook JS SDK on all pages
//             Yii::app()->facebook->renderOGMetaTags(); // this renders the OG tags
//             return true;
//       	}
        
        /**
         * Sends an email with an link to a site where a new password can be generated.
         * This method should only be called, if the user with the given mail address exists.
         * 
         * @param type $language
         * @param type $recipientMail
         * @return boolean
         */
        private function sendNewPasswordMail($language, $recipientMail)
      	{            
            $connection=Yii::app()->db;
            
            /*
             * generate site key
             */
            $length = 30;
            $chars = array_merge(range(0,9), range('a','z'), range('A','Z'));
            shuffle($chars);
            $recovery_key = implode(array_slice($chars, 0, $length)); 
            
             /**
             * get user id from user table by stating the user's email address
             */
            $querryCommand = $connection->createCommand();
            $querryCommand->setFrom('tbl_user');
            $querryCommand->setWhere("email='" . $recipientMail . "'");
            $row = $querryCommand->queryRow(true);
            assert($row == true);
            
            $u_id = $row['u_id'];
            $prename = $row['prename'];
            $name = $row['name'];
            
            /**
             * chek if an entry in the pw_recovery table already exists
             */
            $querryCommand2 = $connection->createCommand();
            $querryCommand2->setFrom('tbl_pw_recovery');
            $querryCommand2->setWhere("u_id='" . $u_id . "'");
            $row2 = $querryCommand2->queryRow(true);
            if($row2 == true)
            {             
               $sql = "UPDATE tbl_pw_recovery SET ".
                   "recovery_key = '".$recovery_key. "', ". 
                   "date = '". "now()" ."' ".
                       "WHERE u_id = '".$u_id."';";
               $connection->createCommand($sql)->execute();   
            }
            else {
                // due to the above assertions we can insert a new row,
               $sql = "INSERT INTO tbl_pw_recovery VALUES (" . 
                       "'" . $u_id ."', ".
                       "'" . "now()" ."', ".                       
                       "'" . $recovery_key ."'".
                       ");";
               $connection->createCommand($sql)->execute(); 
            }
            
            /**
             * Sending activation mail for different languages
             */
            if($language == 'german')
            {      			
                $subject = 'Passwort ändern für ' . Yii::app()->name;
                $content = 'Hallo ' . $prename .' '. $name .',

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
       "http://www.w3.org/TR/html4/strict.dtd">
<html>
<body>														'.	// TODO: use clubname
'		
Soeben haben Sie das Zugangspasswort zu Ihrem Benutzerkonto für '. Yii::app()->name .' angefragt.<br>
<br>
Aus Gründen der Datensicherheit können wir das chiffrierte Passwort allerdings <br>
nicht aus der Datenbank auslesen. <br>
<br>
Da über Ihre E-Mail-Adresse aber der Empfänger sichergestellt ist, <br>
werden Sie stattdessen über diesen Link direkt zu einer sicheren Seite weitergeleitet,<br>
auf der Sie ein neues Passwort festlegen können. <br>
<br>
Bitte beachten Sie, dass der Link nur einmal genutzt werden kann und nach Ablauf von 12 <br>
Stunden seine Gültigkeit verliert. Falls es Ihnen nicht möglich ist, Ihr Passwort innerhalb dieses <br>
Zeitfensters zu ändern, fordern Sie bitte <a href="'. $this->createAbsoluteUrl('site/passwordRecovery') .'">hier</a> einen neue Email an. <br>
Sollten sie keine neues Passwort für ihr Benutzerkonto angefragt haben, können sie diese E-Mail ignorieren.     
<br><br>											
<a href="'.
$this->createAbsoluteUrl('site/genNewPassword', array('mail' => $recipientMail, 'siteKey' => $recovery_key)).'">Ihr neues Passwort können Sie hier anfordern.</a>'.
'</body>
</html>';

                // sending the mail
                Yii::app()->mailer->send($recipientMail, $subject, $content);
                return true;
            }
            elseif($language == 'english')
            {
                // TODO: default english text
                assert($language != 'english');
                return false;
            }
            
            return false;
        }
        
        /**
         * Sends an email with an activation link to the given email address.
         * 
         * This method should only be called, if the user with the given mail address
         * exists and is Not activated, yet.
         * @param type $language
         * @param type $recipientMail
         * @return boolean
         */
      	private function sendActivationMail($language, $recipientMail)
      	{
            $connection=Yii::app()->db;   
            /*
             * generate activation key
             */
            $length = 25;
            $chars = array_merge(range(0,9), range('a','z'), range('A','Z'));
            shuffle($chars);
            $activation_key = implode(array_slice($chars, 0, $length)); 
                        
            /**
             * get user id from user table by stating the user's email address
             */
            $querryCommand = $connection->createCommand();
            $querryCommand->setFrom('tbl_user');
            $querryCommand->setWhere("email='" . $recipientMail . "'");
            $row = $querryCommand->queryRow(true);
            assert($row == true);
            
            $u_id = $row['u_id'];
            $prename = $row['prename'];
            $name = $row['name'];
            assert($row['activated'] == false);  
                        
            /**
             * chek if an entry in the activation table already exists
             */
            $querryCommand2 = $connection->createCommand();
            $querryCommand2->setFrom('tbl_user_activation');
            $querryCommand2->setWhere("u_id='" . $u_id . "'");
            $row2 = $querryCommand2->queryRow(true);
            if($row2 == true)
            {             
               $sql = "UPDATE tbl_user_activation SET ".
                   "activation_key = '".$activation_key. "', ". 
                   "date = '". "now()" ."' ".
                       "WHERE u_id = '".$u_id."';";
               $connection->createCommand($sql)->execute();   
            }
            else {
                // due to the above assertions we can insert a new row,
               $sql = "INSERT INTO tbl_user_activation VALUES (" . 
                       "'" . $u_id ."', ".
                       "'" . "now()" ."', ".                       
                       "'" . $activation_key ."'".
                       ");";
               $connection->createCommand($sql)->execute(); 
            }                
            
                        
            /**
             * Sending activation mail for different languages
             */
            if($language == 'german')
            {      			
                $subject = 'Registrierung bei ' . Yii::app()->name;
                $content = 'Hallo ' . $prename .' '. $name .',
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
       "http://www.w3.org/TR/html4/strict.dtd">
<html>
<body>									'.// TODO: use clubname, not app name
'
Vielen Dank für Ihre Registrierung bei '. Yii::app()->name .'. <br>
Bevor wir Ihre Registrierung abschließen können, müssen Sie einen letzten Schritt machen. <br>
<br>
Anmerkung: Sie müssen diesen letzten Schritt machen, um Ihre Registrierung zu Ende zu führen.<br>
<br>
Um die Registrierung zu vervollständigen, müssen Sie auf diesen Link klicken:<br>'.
$this->createAbsoluteUrl('site/activation', array('mail' => $recipientMail, 'key' => $activation_key)). '<br>
<br>
**** Funktioniert der Link oben nicht? ****<br>
Wenn der Link nicht funktioniert, sollten Sie folgende Adresse in Ihrem Browser aufrufen:<br>'.
$this->createAbsoluteUrl('site/activation'). '<br>
<br>
Bitte achten Sie darauf, dass keine Leerzeichen in der Adresse sind.<br>
Wenn Sie den letzteren Link ( '. $this->createAbsoluteUrl('site/activation'). ' ) benutzt haben, <br>
müssen Sie auf der erscheinenden Seite Ihren E-Mail Adresse, mit der Sie sich registriert haben sowie den Aktivierungscode eingeben. <br>
<br>
<br>
Ihr Aktivierungscode lautet:    '. $activation_key .'<br>
<br>						'. // TODO: club name not app name
'
Sollten Sie sich nicht bei '. Yii::app()->name .' angemeldet haben, können Sie diese E-Mail ignorieren.<br>
<br>
<br>
Vielen Dank,<br>
'. Yii::app()->name.'<br>
</body>
</html>';

                
                // sending the mail
                Yii::app()->mailer->send($recipientMail, $subject, $content);
                return true;
            }
            elseif($language == 'english')
            {
                // TODO: default english text
                assert($language != 'english');
                return false;
            }
            
            
      	}             
}
