<?php 
// protected/data/auth.php

return array(
		
		/**
		 * News tasks/operations
		 */
		
		'read_post' => array (
				'type'=>CAuthItem::TYPE_OPERATION,
				'description'=>'read posts',
				'bizRule'=>'',
				'data'=>''
		),
		
		'create_post' => array (
				'type'=>CAuthItem::TYPE_OPERATION,
				'description'=>'create posts',
				'bizRule'=>'',
				'data'=>''
		),
		
		'comment_post' => array (
				'type'=>CAuthItem::TYPE_OPERATION,
				'description'=>'create comments for a post',
				'bizRule'=>'',
				'data'=>''
		),
		
		'edit_post' => array (
				'type'=>CAuthItem::TYPE_OPERATION,
				'description'=>'edit posts',
				'bizRule'=>'',
				'data'=>''
		),
		
		'edit_own_post' => array (
				'type'=>CAuthItem::TYPE_TASK,
				'description'=>'edit own posts',
				'bizRule'=>'return Yii::app()->user->id==$params["post"]->u_id;',
				'children' => array('edit_post'),
				'data'=>''
		),
		
		/**
		 * news roles
		 */
		
		'reader' => array (
				'type'=>CAuthItem::TYPE_ROLE,
				'description'=>'Can only read posts',
				'bizRule'=>'return !Yii::app()->user->isGuest;',
				'children' => array('read_post'),
				'data'=>''
		),

		'commentor' => array (
				'type'=>CAuthItem::TYPE_ROLE,
				'description'=>'Can read posts and write comments',
				'bizRule'=>'',
				'children' => array('reader', 'comment_post'),
				'data'=>''
		),
		
		'author' => array (
				'type'=>CAuthItem::TYPE_ROLE,
				'description'=>'Can create posts',
				'bizRule'=>'',
				'children' => array('commentor', 'create_post', 'edit_own_post'),
				'data'=>''
		),
		
		'editor' => array (
				'type'=>CAuthItem::TYPE_ROLE,
				'description'=>'Can edit and create posts',
				'children' => array('author', 'edit_post'),
				'bizRule'=>'',
				'data'=>''
		),
		
		/**
		 * club/team managment roles
		 */
		
		'team_manager' => array (
				'type'=>CAuthItem::TYPE_ROLE,
				'description'=>'Can manage a team',
				'bizRule'=>'',
				'children' => array('editor'),
				'data'=>''
		),
		
		'youth_executive' => array (
				'type'=>CAuthItem::TYPE_ROLE,
				'description'=>'can manage youth teams',
				'bizRule'=>'',
				'children' => array('editor'),
				'data'=>''
		),
		
		'club_manager' => array (
				'type'=>CAuthItem::TYPE_ROLE,
				'description'=>'Can manage a club',
				'bizRule'=>'',
				'children' => array('youth_executive'),
				'data'=>''
		),	

		/**
		 * admin
		 */
		
		'admin' => array (
				'type'=>CAuthItem::TYPE_ROLE,
				'description'=>'has superpowers (within a club)',
				'children'=>array(
						'editor', 'club_manager', 'team_manager' 
				),
				'bizRule'=>'',
				'data'=>''
		)
);
?>