<?php

class UserAddress extends CActiveRecord {
      
    
    public $u_id = -1;          // integer starting with 1
    public $visibility = 'private';    
    public $label = 'private';         // character varying(20)
    public $street = '';        // character varying(50)
    public $house_no = '';      
    public $postal_code = '';   
    public $city = '';          // character varying(50)
    public $country = '';       // character varying(50)
    
    
    
    public static function model($className=__CLASS__)
    {
        return parent::model($className);
    }
    
    
    public function rules()
    {
        return array(
            // array('u_id', 'required'),
        	array('visibility', 'in', 'range'=> Visibility::getValidValues() ),
            array('u_id, house_no, postal_code', 'numerical'),
            array('label', 'length', 'min'=>0, 'max'=>20),
            array('street', 'length', 'min'=>0, 'max'=>50),
            // array('city', 'length', 'min'=>0, 'max'=>50),            
            array('country', 'length', 'min'=>0, 'max'=>50),      
        );
    }
    
    protected function afterFind ()
    {
    	if ($this->house_no == 0) {
    		$this->house_no = Null;
    	}
    	
    	if ($this->postal_code == 0) {
    		$this->postal_code = Null;
    	}
    
    	parent::afterFind ();
    }
    
    
    
    public function tableName()
    {
        return 'tbl_address';
    }
    
}
?>
