<?php

/**
 * A model class that aggregates user properties and corresponds
 * to tbl_user_properties
 */
class UserMainProperties extends CActiveRecord {
      
    
    public $u_id = -1;          // integer starting with 1
    public $gender = true;    // true = male; false = female
    public $nickname = Null;
    public $motto = Null;
    public $profession = Null;    //  character varying(30)
    public $website = Null;
    public $birthday = Null;      //  date
    public $img_id = Null;
    
    
    
    public static function model($className=__CLASS__)
    {
        return parent::model($className);
    }
    
    
    public function rules()
    { 
        return array(
            array('u_id, img_id', 'numerical'),
        	//array('gender', 'boolean', 'allowEmpty'),
            array('profession', 'length', 'min'=>0, 'max'=>30),
	       	array('website', 'url', 'defaultScheme' => 'http'),
        	array('birthday', 'date', 'format' => array(
//         		'dd.MM.yyyy', 'd.M.yyyy', 'dd.M.yyyy', 'd.MM.yyyy',
//         		'dd.MM.yy', 'd.M.yy', 'dd.M.yy', 'd.MM.yy',        			
//         		'MM.dd.yyyy', 'M.d.yyyy', 'MM.d.yyyy', 'M.dd.yyyy',
//         		'MM.dd.yy', 'M.d.yy', 'MM.d.yy', 'M.dd.yy',
        		'yyyy-M-d'),
//         		'dd-MM-yyyy'),
        	),    
        );
    }
    
    protected function afterFind ()
    {
    	if ($this->birthday != Null) {
    		$this->birthday = strtotime($this->birthday);
    		$this->birthday = date('d.m.Y', $this->birthday);
    	} 
    	    	
    	parent::afterFind ();
    }
    
    protected function afterValidate() {
    	
    	if ($this->birthday == '') {
    		$this->birthday = Null;
    	}
    	
    	parent::afterValidate ();
    }
    
    public function displayGender() {
    	if($this->gender == true) {
    		return 'männlich';
    	}
    	else {
    		return 'weiblich';
    	}
    }
    
    public function tableName()
    {
        return 'tbl_user_main_properties';
    }
    
}

?>
